<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Person">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Person class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Person class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Person"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the PersonTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.PersonTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Person" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488218926501" sizeMeasure="135">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import java.util.ArrayList;&#xA;&#xA;public class Person {&#xA;&#xA;&#x9;public final static char MALE = 'M';&#xA;&#x9;public final static char FEMALE = 'F';&#xA;&#x9;private final char gender;&#xA;&#x9;private String name;&#xA;&#x9;private Person mother, father;&#xA;&#x9;private ArrayList&lt;Person> children;&#xA;&#x9;&#xA;&#x9;private static boolean isValidGender(char gender) {&#xA;&#x9;&#x9;return gender == MALE || gender == FEMALE;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person(String name, char gender) {&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;if (! isValidGender(gender)) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(gender + &quot; is not a gender&quot;);&#xA;&#x9;&#x9;}&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;this.gender = gender;&#xA;&#x9;&#x9;this.children = new ArrayList&lt;Person>();&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getChild(int index) {&#xA;&#x9;&#x9;return children.get(index);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public String getName() {&#xA;&#x9;&#x9;return name;&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public int getChildCount() {&#xA;&#x9;&#x9;return children.size();&#xA;&#x9;}&#xA;&#xA;&#x9;&#xA;&#x9;public void addChild(Person child) {&#xA;&#xA;&#x9;&#x9;if (children.contains(child)) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;children.add(child);&#xA;&#x9;&#x9;if (this.gender == FEMALE) {&#xA;&#x9;&#x9;&#x9;child.setMother(this);&#xA;&#x9;&#x9;} else if (this.gender == MALE) {&#xA;&#x9;&#x9;&#x9;child.setFather(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void removeChild(Person child) {&#xA;&#xA;&#x9;&#x9;if (! children.contains(child)) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;children.remove(child);&#xA;&#xA;&#x9;&#x9;if (this == child.getFather()) {&#xA;&#x9;&#x9;&#x9;child.setFather(null);&#xA;&#x9;&#x9;} else if (this == child.getMother()) {&#xA;&#x9;&#x9;&#x9;child.setMother(null);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Person getMother() {&#xA;&#x9;&#x9;return mother;&#xA;&#x9;}&#xA;&#xA;&#xA;&#x9;private void checkGender(Person person, char gender) {&#xA;&#x9;&#x9;if (person != null &amp;&amp; person.gender != gender) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;The gender is &quot; + person.gender + &quot; but should be&quot; + gender);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;private void checkOwnParent(Person person, Person parent) {&#xA;&#x9;&#x9;if (person == parent) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Kan ikke være sin egen mor eller far&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public void setMother(Person mother) {&#xA;&#x9;&#x9;checkGender(mother, FEMALE);&#xA;&#x9;&#x9;checkOwnParent(this, mother);&#xA;&#x9;&#x9;if (mother == this.mother) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;if (this.mother != null) {&#xA;&#x9;&#x9;&#x9;this.mother.removeChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.mother = mother;&#xA;&#xA;&#x9;&#x9;if (this.mother != null) {&#xA;&#x9;&#x9;&#x9;this.mother.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;public Person getFather() {&#xA;&#x9;&#x9;return father;&#xA;&#x9;}&#xA;&#xA;&#x9;public void setFather(Person father) {&#xA;&#x9;&#x9;checkGender(father, MALE);&#xA;&#x9;&#x9;checkOwnParent(this, father);&#xA;&#x9;&#x9;if (father == this.father) {&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;}&#xA;&#xA;&#x9;&#x9;if (this.father != null) {&#xA;&#x9;&#x9;&#x9;this.father.removeChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.father = father;&#xA;&#xA;&#x9;&#x9;if (this.father != null) {&#xA;&#x9;&#x9;&#x9;this.father.addChild(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#xA;&#x9;private static boolean isAncestorOf(Person ancestor, Person person) {&#xA;&#x9;&#x9;if (person == null) {&#xA;&#x9;&#x9;&#x9;return false;&#xA;&#x9;&#x9;} else if (ancestor == person) {&#xA;&#x9;&#x9;&#x9;return true;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return isAncestorOf(ancestor, person.father) || isAncestorOf(ancestor, person.mother);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isAncestorOf(Person person) {&#xA;&#x9;&#x9;return isAncestorOf(this, person.father) || isAncestorOf(this, person.mother);&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217704899" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217707850" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217715616" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488218935215" completion="1.0" successCount="13"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488218964882" completion="1.0" successCount="13"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
