<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Card">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Card class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Card"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardDeck class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the CardHand class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardDeck class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardDeck"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the CardHand class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.CardHand"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardDeckTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardDeckTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the CardHandTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.CardHandTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Card*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213013469" sizeMeasure="65">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;import encapsulation.Card;&#xA;&#xA;public class CardDeck {&#xA;&#x9;private Card[] _deck;&#xA;&#x9;private char[] _suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;_deck = new Card[n*4];&#xA;&#x9;&#x9;int i = 0;&#xA;&#x9;&#x9;for (char suit : _suits) {&#xA;&#x9;&#x9;&#x9;for (int faceNumber = 1; faceNumber &lt;= n; faceNumber++) {&#xA;&#x9;&#x9;&#x9;&#x9;_deck[i] = new Card(suit, faceNumber);&#xA;&#x9;&#x9;&#x9;&#x9;i++;&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return _deck.length;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= 0 &amp;&amp; n &lt; getCardCount()) {&#xA;&#x9;&#x9;&#x9;return _deck[n];&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot find card in deck with this index&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;Card[] tempDeck1 = new Card[getCardCount()/2];&#xA;&#x9;&#x9;Card[] tempDeck2 = new Card[getCardCount()/2];&#xA;&#x9;&#x9;System.arraycopy(_deck, 0, tempDeck1, 0, tempDeck1.length);&#xA;&#x9;&#x9;System.arraycopy(_deck, tempDeck1.length, tempDeck2, 0, tempDeck2.length);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;int cardNumber = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; tempDeck1.length; i++) {&#xA;&#x9;&#x9;&#x9;_deck[cardNumber] = tempDeck1[i];&#xA;&#x9;&#x9;&#x9;_deck[cardNumber].toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;&#x9;_deck[cardNumber] = tempDeck2[i];&#xA;&#x9;&#x9;&#x9;_deck[cardNumber].toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand cardHand, int n) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String deckString = new String();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; _deck.length; i++) {&#xA;&#x9;&#x9;&#x9;deckString += _deck[i].toString();&#xA;&#x9;&#x9;&#x9;deckString += &quot;, &quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return deckString;&#xA;&#x9;}&#xA;}&#xA;&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213670485" sizeMeasure="64" errorCount="8">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class CardDeck {&#xA;&#x9;private ArrayList&lt;Card> _deck;&#xA;&#x9;private char[] _suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;//_deck = new Card[n*4];&#xA;&#x9;&#x9;for (char suit : _suits) {&#xA;&#x9;&#x9;&#x9;for (int faceNumber = 1; faceNumber &lt;= n; faceNumber++) {&#xA;&#x9;&#x9;&#x9;&#x9;_deck.add(new Card(suit, faceNumber))" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="54" end="-1053"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="432" charEnd="438" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="523" charEnd="531" severity="2" problemCategory="60" problemType="536871062"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="985" charEnd="1002" severity="2" problemCategory="60" problemType="536871062"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="41" charStart="1022" charEnd="1039" severity="2" problemCategory="60" problemType="536871062"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1072" charEnd="1089" severity="2" problemCategory="60" problemType="536871062"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1109" charEnd="1126" severity="2" problemCategory="60" problemType="536871062"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1314" charEnd="1320" severity="2" problemCategory="50" problemType="33554502"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="57" charStart="1346" charEnd="1354" severity="2" problemCategory="60" problemType="536871062"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214707948" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.List;&#xA;&#xA;public class CardDeck {&#xA;&#x9;private ArrayList&lt;Card> deck;&#xA;&#x9;private char[] _suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;//_deck = new Card[n*4];&#xA;&#x9;&#x9;for (char suit : _suits) {&#xA;&#x9;&#x9;&#x9;for (int faceNumber = 1; faceNumber &lt;= n; faceNumber++) {&#xA;&#x9;&#x9;&#x9;&#x9;deck.add(new Card(suit, faceNumber));&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return deck.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= 0 &amp;&amp; n &lt; getCardCount()) {&#xA;&#x9;&#x9;&#x9;return deck.get(n);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot find card in deck with this index&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;List&lt;Card> tempDeck1 = deck.subList(0, getCardCount()/2);&#xA;&#x9;&#x9;List&lt;Card> tempDeck2 = deck.subList(getCardCount()/2, getCardCount());&#xA;&#x9;&#x9;int cardNumber = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; tempDeck1.size(); i++) {&#xA;&#x9;&#x9;&#x9;deck.set(cardNumber, tempDeck1.get(i));&#xA;&#x9;&#x9;&#x9;deck.get(cardNumber).toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;&#x9;deck.set(cardNumber, tempDeck2.get(i));&#xA;&#x9;&#x9;&#x9;deck.get(cardNumber).toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand cardHand, int n) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String deckString = new String();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; deck.size(); i++) {&#xA;&#x9;&#x9;&#x9;deckString += deck.get(i)" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="82" end="-71"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215088194" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;int highestIndex = deck.size();&#xA;&#x9;&#x9;&#x9;Card topCard = deck.get(highestIndex);&#xA;&#x9;&#x9;&#x9;deck.remove(highestIndex);&#xA;&#x9;&#x9;&#x9;cardHand.addCard(topCard);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="1147" end="-214"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215201121" sizeMeasure="67">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {&#xA;&#x9;&#x9;//_deck = new Card[n*4];&#xA;&#x9;&#x9;for (char suit : " edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="177" end="-1248"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215475556" sizeMeasure="72">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main() {&#xA;&#x9;&#x9;CardDeck cardDeck = new CardDeck(4);&#xA;&#x9;&#x9;System.out.println(cardDeck.toString())" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="1525" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215586935" sizeMeasure="73">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(this);" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="403" end="-1244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215787965" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="34" end="-1620"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1295" charEnd="1302" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215922885" sizeMeasure="72" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="34" end="-1620"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1295" charEnd="1302" severity="2" problemCategory="50" problemType="67108979"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488216224555" sizeMeasure="71">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class CardDeck {&#xA;&#x9;private ArrayList&lt;Card> deck = new ArrayList&lt;Card>();&#xA;&#x9;private char[] suits = {'S', 'H', 'D', 'C'};&#xA;&#x9;&#xA;&#x9;public CardDeck(int n) {" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="34" end="-1412"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488216373245" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="373" end="-1244"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488216459434" sizeMeasure="70">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return deck.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= 0 &amp;&amp; n &lt; getCardCount()) {&#xA;&#x9;&#x9;&#x9;return deck.get(n);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot find card in deck with this index&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void shufflePerfectly() {&#xA;&#x9;&#x9;List&lt;Card> tempDeck1 = deck.subList(0, getCardCount()/2);&#xA;&#x9;&#x9;List&lt;Card> tempDeck2 = deck.subList(getCardCount()/2, getCardCount());&#xA;&#x9;&#x9;int cardNumber = 0;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; tempDeck1.size(); i++) {&#xA;&#x9;&#x9;&#x9;deck.set(cardNumber, tempDeck1.get(i));&#xA;&#x9;&#x9;&#x9;deck.get(cardNumber).toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;&#x9;deck.set(cardNumber, tempDeck2.get(i));&#xA;&#x9;&#x9;&#x9;deck.get(cardNumber).toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand cardHand, int n) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;int highestIndex = deck.size() - 1" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="373" end="-437"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488216940448" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;String deckString = new String();&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; deck.size(); i++) {&#xA;&#x9;&#x9;&#x9;deckString += deck.get(i).toString();&#xA;&#x9;&#x9;&#x9;deckString += &quot;, &quot;;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;return deckString" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="1291" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217054168" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(this);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void deal(CardHand cardHand, int n) {&#xA;&#x9;&#x9;for (int i = 0; i &lt; n; i++) {&#xA;&#x9;&#x9;&#x9;int highestIndex = deck.size() - 1;&#xA;&#x9;&#x9;&#x9;Card topCard = deck.get(highestIndex);&#xA;&#x9;&#x9;&#x9;deck.remove(highestIndex);&#xA;&#x9;&#x9;&#x9;cardHand.addCard(topCard);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="1063" end="-214"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217147344" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", getCardCount()/2" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="773" end="-740"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217222064" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="/2, getCardCount()" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="773" end="-740"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217260397" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tempDeck2.size() - " edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1000" end="-531"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217294736" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="1" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1019" end="-534"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217311737" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="1000" end="-531"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217380243" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1530" end="-1531"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217544067" sizeMeasure="66">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;&#x9;deck.get(cardNumber).toString();&#xA;&#x9;&#x9;&#x9;cardNumber++;&#xA;&#x9;&#x9;&#x9;deck.set(cardNumber, tempDeck2.get(i));&#xA;//" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="909" end="-526"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217864049" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ArrayList&lt;Card> shuffledDeck = new ArrayList&lt;Card>();&#xA;&#x9;&#x9;List&lt;Card> tempDeck1 = deck.subList(0, getCardCount()/2);&#xA;&#x9;&#x9;List&lt;Card> tempDeck2 = deck.subList(getCardCount()/2, getCardCount());&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for (int i = 0; i &lt; tempDeck1.size(); i++) {&#xA;&#x9;&#x9;&#x9;shuffledDeck.add(tempDeck1.get(i));&#xA;&#x9;&#x9;&#x9;shuffledDeck.add(tempDeck2.get(i))" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="663" end="-475"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488217890186" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="deck = shuffledDeck;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="984" end="-470"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488212976837" sizeMeasure="5">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class CardHand {&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213146476" sizeMeasure="23">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import encapsulation.Card;&#xA;&#xA;public class CardHand {&#xA;&#x9;&#xA;&#x9;private Card[] deck;&#xA;&#x9;public CardHand() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return deck.length;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= 0 &amp;&amp; n &lt; getCardCount()) {&#xA;&#x9;&#x9;&#x9;return deck[n];&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot find card in deck with this index&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.2/@attempts.0/@edit" start="27" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488213398214" sizeMeasure="31">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;&#xA;public class CardHand {&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Card> deck;&#xA;&#x9;public CardHand() {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;// Standard Methods&#xA;&#x9;public int getCardCount() {&#xA;&#x9;&#x9;return deck.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Card getCard(int n) {&#xA;&#x9;&#x9;if (n >= 0 &amp;&amp; n &lt; getCardCount()) {&#xA;&#x9;&#x9;&#x9;return deck.get(n);&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Cannot find card in deck with this index&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public void addCard(Card card) {&#xA;&#x9;&#x9;deck.add(card);" edit="/1/@proposals.0/@proposals.2/@attempts.1/@edit" start="54" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488214809939" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public Card play(int n) {&#xA;&#x9;&#x9;Card card = deck.get(n);&#xA;&#x9;&#x9;deck.remove(n);&#xA;&#x9;&#x9;return card" edit="/1/@proposals.0/@proposals.2/@attempts.2/@edit" start="499" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488215929962" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.2/@attempts.3/@edit" start="34" end="-541"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1488216875806" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="java.util.ArrayList;&#xA;&#xA;public class CardHand {&#xA;&#x9;&#xA;&#x9;private ArrayList&lt;Card> deck = new ArrayList&lt;Card>()" edit="/1/@proposals.0/@proposals.2/@attempts.4/@edit" start="34" end="-456"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215674954" completion="1.0" successCount="2">
          <successTests>testToString</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.6/@q" answer="/0/@parts.0/@tasks.6/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215149273" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215247526" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215484915" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215588269" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215700639" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215798196" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215939667" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215971017" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215979920" completion="0.0" errorCount="3">
          <errorTests>testShufflePerfectly</errorTests>
          <errorTests>testDeal</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216227755" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216260273" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216374195" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216470053" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216535535" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216630487" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216644204" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216819140" completion="0.3333333333333333" successCount="1" failureCount="1" errorCount="1">
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
          <errorTests>testDeal</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216877974" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488216941578" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217055536" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217148791" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testShufflePerfectly</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217282431" completion="0.6666666666666666" successCount="2" errorCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testShufflePerfectly</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217296585" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217381307" completion="0.6666666666666666" successCount="2" failureCount="1">
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testShufflePerfectly</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488217891005" completion="1.0" successCount="3">
          <successTests>testShufflePerfectly</successTests>
          <successTests>testDeal</successTests>
          <successTests>testConstructor</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.7/@q" answer="/0/@parts.0/@tasks.7/@a" completion="0.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1488215136029" completion="0.0" errorCount="3">
          <errorTests>testDeal</errorTests>
          <errorTests>testDealPlay</errorTests>
          <errorTests>testConstructor</errorTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a" performedCount="7">
        <attempts timestamp="1488215996166"/>
        <attempts timestamp="1488216542010"/>
        <attempts timestamp="1488216821454"/>
        <attempts timestamp="1488216833216"/>
        <attempts timestamp="1488217396117"/>
        <attempts timestamp="1488217544764"/>
        <attempts timestamp="1488217601410"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a" performedCount="32">
        <attempts timestamp="1488216015700"/>
        <attempts timestamp="1488216021815"/>
        <attempts timestamp="1488216023903"/>
        <attempts timestamp="1488216029863"/>
        <attempts timestamp="1488216041647"/>
        <attempts timestamp="1488216066063"/>
        <attempts timestamp="1488216114998"/>
        <attempts timestamp="1488216118595"/>
        <attempts timestamp="1488216151517"/>
        <attempts timestamp="1488216567534"/>
        <attempts timestamp="1488216580677"/>
        <attempts timestamp="1488216595283"/>
        <attempts timestamp="1488216608500"/>
        <attempts timestamp="1488216610386"/>
        <attempts timestamp="1488216615627"/>
        <attempts timestamp="1488216616609"/>
        <attempts timestamp="1488216618514"/>
        <attempts timestamp="1488216619835"/>
        <attempts timestamp="1488216829557"/>
        <attempts timestamp="1488216830324"/>
        <attempts timestamp="1488216831090"/>
        <attempts timestamp="1488216831800"/>
        <attempts timestamp="1488216833213"/>
        <attempts timestamp="1488216847582"/>
        <attempts timestamp="1488217471799"/>
        <attempts timestamp="1488217478861"/>
        <attempts timestamp="1488217552980"/>
        <attempts timestamp="1488217557555"/>
        <attempts timestamp="1488217565162"/>
        <attempts timestamp="1488217587147"/>
        <attempts timestamp="1488217601407"/>
        <attempts timestamp="1488217606705"/>
      </proposals>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" performedCount="1">
        <attempts timestamp="1488216012165"/>
      </proposals>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a" performedCount="4">
        <attempts timestamp="1488216133164"/>
        <attempts timestamp="1488216598597"/>
        <attempts timestamp="1488217407455"/>
        <attempts timestamp="1488217547719"/>
      </proposals>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
