<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Twitter">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Tweet class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the TwitterAccount class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Tweet class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.Tweet"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the TwitterAccount class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="objectstructures.TwitterAccount"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TweetTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TweetTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the TwitterAccountTest JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="objectstructures.TwitterAccountTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the Tweet class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.Tweet" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug the TwitterAccount class."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="objectstructures.TwitterAccount" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967117167" sizeMeasure="60">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class Tweet {&#xA;&#x9;&#xA;&#x9;private String tweet;&#xA;&#x9;private int retweets = 0;&#xA;&#x9;private Tweet originalTweet = null;&#xA;&#x9;private TwitterAccount owner;&#xA;&#x9;&#xA;&#x9;public Tweet (TwitterAccount owner, String tweet) {&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;this.tweet = tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet(TwitterAccount owner, Tweet reTweet) {&#xA;&#x9;&#x9;if (reTweet.getOwner() == owner) {&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;You cannot retweet your own tweet.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.owner = owner;&#xA;&#x9;&#x9;if (reTweet.getOriginalTweet() == null) {&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;this.tweet = reTweet.getText();&#xA;&#x9;&#x9;&#x9;reTweet.incrementRetweetCount();&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.tweet = reTweet.getOriginalTweet().getText();&#xA;&#x9;&#x9;&#x9;reTweet.getOriginalTweet().incrementRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.originalTweet = reTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;// Return text in tweet&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;// Return owner of tweet&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;// Return original tweet if the tweet was retweeted, else return null&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;// Return number of retweets&#xA;&#x9;&#x9;return retweets;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void incrementRetweetCount() {&#xA;&#x9;&#x9;// Increment reetweet count by 1&#xA;&#x9;&#x9;retweets++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet: &quot; + this.tweet + &quot; @&quot; + this.owner.getUserName();&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967272891" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &#xA;&#x9;&#x9;&#x9;&#x9;originalTweet != null ? &quot;retweet of @&quot; + originalTweet.getOwner().getUserName() : &quot;&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.0/@edit" start="1323" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967306140" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="(originalTweet != null ? (&quot;retweet of @&quot; + originalTweet.getOwner().getUserName()) : &quot;&quot;)" edit="/1/@proposals.0/@proposals.0/@attempts.1/@edit" start="1331" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967317761" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" " edit="/1/@proposals.0/@proposals.0/@attempts.2/@edit" start="1358" end="-70"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967403597" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Original post by" edit="/1/@proposals.0/@proposals.0/@attempts.3/@edit" start="1359" end="-60"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967419061" sizeMeasure="61">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="." edit="/1/@proposals.0/@proposals.0/@attempts.4/@edit" start="1358" end="-77"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967532325" sizeMeasure="62" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="@&quot; + this.owner.getUserName() + &#xA;&#x9;&#x9;&#x9;&#x9;(originalTweet != null ? (&quot; retweeted @&quot; + originalTweet.getOwner().getUserName()) : &quot;&quot;) + &#xA;&#x9;&#x9;&#x9;&#x9;&quot; &quot; + this.tweet;&#x9;&#x9;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.0/@attempts.5/@edit" start="1275" end="-9"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1487" charEnd="1488" severity="2" problemCategory="60" problemType="536871073"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967542251" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.6/@edit" start="1425" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967562083" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=": &quot; + this.tweet" edit="/1/@proposals.0/@proposals.0/@attempts.7/@edit" start="1410" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967617337" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" + &quot;\nRetweets: &quot; + getRetweetCount() + &quot;\n\n&quot;" edit="/1/@proposals.0/@proposals.0/@attempts.8/@edit" start="1426" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968489382" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.9/@edit" start="1480" end="-1481"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969859206" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.10/@edit" start="1469" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970906557" sizeMeasure="63">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;this.originalTweet = reTweet;&#xA;&#x9;&#x9;} else {&#xA;&#x9;&#x9;&#x9;this.tweet = reTweet.getOriginalTweet().getText();&#xA;&#x9;&#x9;&#x9;reTweet.getOriginalTweet().incrementRetweetCount();&#xA;&#x9;&#x9;&#x9;this.originalTweet = reTweet.getOriginalTweet();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getText() {&#xA;&#x9;&#x9;// Return text in tweet&#xA;&#x9;&#x9;return tweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public TwitterAccount getOwner() {&#xA;&#x9;&#x9;// Return owner of tweet&#xA;&#x9;&#x9;return owner;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getOriginalTweet() {&#xA;&#x9;&#x9;// Return original tweet if the tweet was retweeted, else return null&#xA;&#x9;&#x9;return originalTweet;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;// Return number of retweets&#xA;&#x9;&#x9;return retweets;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void incrementRetweetCount() {&#xA;&#x9;&#x9;// Increment reetweet count by 1&#xA;&#x9;&#x9;retweets++;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;Tweet: @&quot; + this.owner.getUserName() + &#xA;&#x9;&#x9;&#x9;&#x9;(originalTweet != null ? (&quot; retweeted @&quot; + originalTweet.getOwner().getUserName()) : &quot;&quot;) + &#xA;&#x9;&#x9;&#x9;&#x9;&quot; : &quot; + this.tweet + &quot;\nRetweets: &quot; + getRetweetCount() + &quot;" edit="/1/@proposals.0/@proposals.0/@attempts.11/@edit" start="585" end="-12"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970988062" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.tweet = reTweet.getText();&#xA;&#x9;&#x9;if (reTweet.getOriginalTweet() == null) {&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;&#x9;reTweet.incrementRetweetCount();&#xA;&#x9;&#x9;&#x9;this.originalTweet = reTweet;&#xA;&#x9;&#x9;} else {" edit="/1/@proposals.0/@proposals.0/@attempts.12/@edit" start="467" end="-852"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487972053244" sizeMeasure="62">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.0/@attempts.13/@edit" start="1476" end="-1477"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487966762778" sizeMeasure="11" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package objectstructures;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String userName;&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="5" charStart="79" charEnd="87" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487966814990" sizeMeasure="16">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() {&#xA;&#x9;&#x9;return &quot;[ TwitterAccount &quot; + userName + &quot;]&quot;" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="161" end="-9"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487966821778" sizeMeasure="20">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.1/@edit" start="252" end="-8"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487966984050" sizeMeasure="25" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount a1 = new TwitterAccount(&quot;Lise&quot;);&#xA;&#x9;&#x9;TwitterAccount a2 = new TwitterAccount(&quot;Lise&quot;);&#xA;&#x9;&#x9;Tweet t1 = new Tweet(a1, &quot;Shallabais&quot;);&#xA;&#x9;&#x9;Tweet t2 = new Tweet(a2, &quot;Du kan ikke stoppe meg&quot;);&#xA;&#x9;&#x9;Tweet t3 = new Tweet(a1, t1);" edit="/1/@proposals.0/@proposals.1/@attempts.2/@edit" start="298" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="465" charEnd="467" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="520" charEnd="522" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487966995469" sizeMeasure="25" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="2" edit="/1/@proposals.0/@proposals.1/@attempts.3/@edit" start="516" end="-17"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="20" charStart="465" charEnd="467" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="21" charStart="520" charEnd="522" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967111149" sizeMeasure="29" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="public String getUserName() {&#xA;&#x9;&#x9;return" edit="/1/@proposals.0/@proposals.1/@attempts.4/@edit" start="164" end="-387"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="25" charStart="579" charEnd="581" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="24" charStart="524" charEnd="526" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967136787" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(t1);&#xA;&#x9;&#x9;System.out.println(t2);&#xA;&#x9;&#x9;System.out.println(t3" edit="/1/@proposals.0/@proposals.1/@attempts.5/@edit" start="583" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967147282" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Johannes" edit="/1/@proposals.0/@proposals.1/@attempts.6/@edit" start="443" end="-223"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967419072" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.7/@edit" start="673" end="-674"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967567927" sizeMeasure="33">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.8/@edit" start="673" end="-674"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487967715001" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String userName;&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>()" edit="/1/@proposals.0/@proposals.1/@attempts.9/@edit" start="27" end="-591"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="166" charEnd="172" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968024617" sizeMeasure="65" errorCount="26">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="// Return username&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){&#xA;&#x9;&#x9;// Start following account if not already following, and not itself&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// Stop following account if following&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) {&#xA;&#x9;&#x9;// True if following account, false if not following&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account)  {&#xA;&#x9;&#x9;// True if followed by account, false if not followed by account&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweetText) {&#xA;&#x9;&#x9;// Create new tweet for account&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) {&#xA;&#x9;&#x9;// Retweeting a tweet if it is not your own tweet- retweeter tweet fra denne kontoen&#xA;&#x9;}&#xA;&#x9;Tweet getTweet(int i) - returner tweet nummer i, der 1 er den nyeste, 2 den nest nyeste, … (merk rekkefølgen!)&#xA;&#x9;int getTweetCount() - returner antall tweets til kontoen&#xA;&#x9;int getRetweetCount() - returner antall retweets av tweets fra denne kontoen" edit="/1/@proposals.0/@proposals.1/@attempts.10/@edit" start="302" end="-459"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1244" charEnd="1252" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1260" charEnd="1268" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1269" charEnd="1271" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1279" charEnd="1282" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1283" charEnd="1288" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1289" charEnd="1296" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1289" charEnd="1296" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1070" charEnd="1071" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1072" charEnd="1080" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1081" charEnd="1086" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1087" charEnd="1093" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1094" charEnd="1095" severity="2" problemCategory="60" problemType="536870967"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1101" charEnd="1102" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1103" charEnd="1119" severity="2" problemCategory="20" problemType="1610612972"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1106" charEnd="1109" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1120" charEnd="1123" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1124" charEnd="1128" severity="2" problemCategory="20" problemType="1610612972"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1129" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="43" charStart="1129" charEnd="1135" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1181" charEnd="1182" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1183" charEnd="1191" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1199" charEnd="1205" severity="2" problemCategory="20" problemType="1610612940"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1206" charEnd="1209" severity="2" problemCategory="40" problemType="16777218"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1210" charEnd="1217" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1210" charEnd="1217" severity="2" problemCategory="20" problemType="1610612976"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1242" charEnd="1243" severity="2" problemCategory="20" problemType="1610612940"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968185341" sizeMeasure="74" errorCount="5" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (checking this in Tweet, no need to check it here&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;// Return tweet #i, 1 is newest tweet, 2 is second newest etc, &#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() {&#xA;&#x9;&#x9;// Return tweetcount&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() {&#xA;&#x9;&#x9;// Return #retweets from account combined&#xA;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.11/@edit" start="966" end="-459"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="44" charStart="1079" charEnd="1094" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1184" charEnd="1199" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1246" charEnd="1263" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="9" charStart="166" charEnd="172" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="602" charEnd="637" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="720" charEnd="756" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968367048" sizeMeasure="75" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, &quot;tweetText&quot;));" edit="/1/@proposals.0/@proposals.1/@attempts.12/@edit" start="861" end="-847"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="602" charEnd="637" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="720" charEnd="756" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1115" charEnd="1130" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1220" charEnd="1235" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1282" charEnd="1299" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968375710" sizeMeasure="75" errorCount="5">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.13/@edit" start="1754" end="-1755"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="45" charStart="1115" charEnd="1130" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="49" charStart="1220" charEnd="1235" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="53" charStart="1282" charEnd="1299" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="28" charStart="602" charEnd="637" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="32" charStart="720" charEnd="756" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968419471" sizeMeasure="77" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;TwitterAccount> following = new ArrayList&lt;TwitterAccoun" edit="/1/@proposals.0/@proposals.1/@attempts.14/@edit" start="192" end="-1570"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="47" charStart="1267" charEnd="1282" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="51" charStart="1372" charEnd="1387" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="55" charStart="1434" charEnd="1451" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968460557" sizeMeasure="78" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=")&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, tweet));" edit="/1/@proposals.0/@proposals.1/@attempts.15/@edit" start="1201" end="-704"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1310" charEnd="1325" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1415" charEnd="1430" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1477" charEnd="1494" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968519107" sizeMeasure="78" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.16/@edit" start="1946" end="-1947"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1310" charEnd="1325" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="52" charStart="1415" charEnd="1430" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1477" charEnd="1494" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968630143" sizeMeasure="81" errorCount="5" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // Done&#xA;&#x9;&#x9;// Create new tweet&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, &quot;tweetText&quot;));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) { //Done&#xA;&#x9;&#x9;// Retweeting a tweet if it is not your own tweet (checking this in Tweet, no need to check it here)&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) {&#xA;&#x9;&#x9;// Return tweet #i, 1 is newest tweet, 2 is second newest etc, &#xA;&#x9;&#x9;if (i > 0 &amp;&amp; i &lt; getTweetCount()) {&#xA;&#x9;&#x9;&#x9;return tweets.get(i-1);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.17/@edit" start="989" end="-601"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="59" charStart="1564" charEnd="1581" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="48" charStart="1325" charEnd="1340" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="55" charStart="1502" charEnd="1517" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968643871" sizeMeasure="82" errorCount="4" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return null;" edit="/1/@proposals.0/@proposals.1/@attempts.18/@edit" start="1432" end="-601"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="56" charStart="1518" charEnd="1533" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="60" charStart="1580" charEnd="1597" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968673076" sizeMeasure="83" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Done&#xA;&#x9;&#x9;// Return tweet #i, 1 is newest tweet, 2 is second newest etc, &#xA;&#x9;&#x9;if (i > 0 &amp;&amp; i &lt; getTweetCount()) {&#xA;&#x9;&#x9;&#x9;return tweets.get(i-1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() { //Done&#xA;&#x9;&#x9;// Return tweetcount&#xA;&#x9;&#x9;return tweets.size();" edit="/1/@proposals.0/@proposals.1/@attempts.19/@edit" start="1295" end="-543"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1619" charEnd="1636" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968727614" sizeMeasure="87" errorCount="3" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;int count = 0;&#xA;&#x9;&#x9;for (Tweet t : tweets) {&#xA;&#x9;&#x9;&#x9;count += t.getRetweetCount();&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.20/@edit" start="1624" end="-462"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="61" charStart="1619" charEnd="1636" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968735836" sizeMeasure="88" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;return count;" edit="/1/@proposals.0/@proposals.1/@attempts.21/@edit" start="1705" end="-462"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968740013" sizeMeasure="88" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Done" edit="/1/@proposals.0/@proposals.1/@attempts.22/@edit" start="1578" end="-603"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968747854" sizeMeasure="88" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Done" edit="/1/@proposals.0/@proposals.1/@attempts.23/@edit" start="1770" end="-418"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="754" charEnd="789" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="872" charEnd="908" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968758626" sizeMeasure="88" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Done" edit="/1/@proposals.0/@proposals.1/@attempts.24/@edit" start="449" end="-1746"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="11" charStart="306" charEnd="315" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="30" charStart="761" charEnd="796" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="34" charStart="879" charEnd="915" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968818827" sizeMeasure="91" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (account != this &amp;&amp; !following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.add(account);&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.25/@edit" start="618" end="-1586"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="970" charEnd="1006" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="852" charEnd="887" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968826854" sizeMeasure="91" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Done" edit="/1/@proposals.0/@proposals.1/@attempts.26/@edit" start="546" end="-1744"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="33" charStart="859" charEnd="894" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="37" charStart="977" charEnd="1013" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968896790" sizeMeasure="94" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Not Done&#xA;&#x9;&#x9;// Start following account if not already following, and not itself&#xA;&#x9;&#x9;if (account != this &amp;&amp; !following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// Stop following account if following&#xA;&#x9;&#x9;if (following.contains(account)) {&#xA;&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}" edit="/1/@proposals.0/@proposals.1/@attempts.27/@edit" start="549" end="-1492"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="911" charEnd="946" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1029" charEnd="1065" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487968909467" sizeMeasure="94" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="following.remove(account);" edit="/1/@proposals.0/@proposals.1/@attempts.28/@edit" start="850" end="-1496"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="36" charStart="937" charEnd="972" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="40" charStart="1055" charEnd="1091" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969225849" sizeMeasure="100" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if (!account.isFollowedBy(this)) {&#xA;&#x9;&#x9;&#x9;account.follow(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// Stop following account if following&#xA;&#x9;&#x9;if (following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (account.isFollowing(this)) {&#xA;&#x9;&#x9;&#x9;account.unfollow(this" edit="/1/@proposals.0/@proposals.1/@attempts.29/@edit" start="717" end="-1498"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="10" charStart="230" charEnd="239" severity="1" problemCategory="120" problemType="570425421"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="42" charStart="1075" charEnd="1110" severity="2" problemCategory="50" problemType="603979884"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="46" charStart="1193" charEnd="1229" severity="2" problemCategory="50" problemType="603979884"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969645006" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers.add(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// Stop following account if following&#xA;&#x9;&#x9;if (following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (account.isFollowedBy(this)) {&#xA;&#x9;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) { //Done&#xA;&#x9;&#x9;// True if following account, false if not following&#xA;&#x9;&#x9;return following.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account)  { //Done&#xA;&#x9;&#x9;// True if followed by account, false if not followed by account&#xA;&#x9;&#x9;return followers.contains(account);" edit="/1/@proposals.0/@proposals.1/@attempts.30/@edit" start="770" end="-1250"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969826697" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Lise = new TwitterAccount(&quot;Lise&quot;);&#xA;&#x9;&#x9;TwitterAccount a2 = new TwitterAccount(&quot;Johannes&quot;);&#xA;&#x9;&#x9;Tweet t1 = new Tweet(Lise" edit="/1/@proposals.0/@proposals.1/@attempts.31/@edit" start="2304" end="-194"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969836658" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Johannes = new TwitterAccount(&quot;Johannes&quot;);&#xA;&#x9;&#x9;Tweet t1 = new Tweet(Lise, &quot;Shallabais&quot;);&#xA;&#x9;&#x9;Tweet t2 = new Tweet(Johannes, &quot;Du kan ikke stoppe meg&quot;);&#xA;&#x9;&#x9;Tweet t3 = new Tweet(Johannes" edit="/1/@proposals.0/@proposals.1/@attempts.32/@edit" start="2356" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969845405" sizeMeasure="102">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.33/@edit" start="2631" end="-2632"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969921846" sizeMeasure="104">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays;&#xA;import java.util.List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String userName;&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() { //Done&#xA;&#x9;&#x9;// Return username&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){ //Not Done&#xA;&#x9;&#x9;// Start following account if not already following, and not itself&#xA;&#x9;&#x9;if (account != this &amp;&amp; !following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (!account.isFollowedBy(this)) {&#xA;&#x9;&#x9;&#x9;account.followers.add(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// Stop following account if following&#xA;&#x9;&#x9;if (following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (account.isFollowedBy(this)) {&#xA;&#x9;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) { //Done&#xA;&#x9;&#x9;// True if following account, false if not following&#xA;&#x9;&#x9;return following.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account)  { //Done&#xA;&#x9;&#x9;// True if followed by account, false if not followed by account&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweetText) { // Done&#xA;&#x9;&#x9;// Create new tweet&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, &quot;tweetText&quot;));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) { //Done&#xA;&#x9;&#x9;// Retweeting a tweet if it is not your own tweet (checking this in Tweet, no need to check it here)&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) { //Done&#xA;&#x9;&#x9;// Return tweet #i, 1 is newest tweet, 2 is second newest etc, &#xA;&#x9;&#x9;if (i > 0 &amp;&amp; i &lt; getTweetCount()) {&#xA;&#x9;&#x9;&#x9;return tweets.get(i-1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return null;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() { //Done&#xA;&#x9;&#x9;// Return tweetcount&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() { //Done&#xA;&#x9;&#x9;// Return #retweets from account combined&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for (Tweet t : tweets) {&#xA;&#x9;&#x9;&#x9;count += t.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return count;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() { //Done&#xA;&#x9;&#x9;return &quot;[ TwitterAccount &quot; + userName + &quot; Followers: &quot; + Arrays.asList(followers).toString() + &quot;]&quot;;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Lise = new TwitterAccount(&quot;Lise&quot;);&#xA;&#x9;&#x9;TwitterAccount Johannes = new TwitterAccount(&quot;Johannes&quot;);&#xA;&#x9;&#x9;Tweet t1 = new Tweet(Lise, &quot;Shallabais&quot;);&#xA;&#x9;&#x9;Tweet t2 = new Tweet(Johannes, &quot;Du kan ikke stoppe meg&quot;);&#xA;&#x9;&#x9;Tweet t3 = new Tweet(Johannes, t1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(t1);&#xA;&#x9;&#x9;System.out.println(t2);&#xA;&#x9;&#x9;System.out.println(t3);&#xA;&#x9;&#x9;" edit="/1/@proposals.0/@proposals.1/@attempts.34/@edit" start="72" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969948816" sizeMeasure="103" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Lise.follow(Johannes);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(" edit="/1/@proposals.0/@proposals.1/@attempts.35/@edit" start="2623" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2624" charEnd="2626" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2685" charEnd="2687" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969952957" sizeMeasure="103" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Lise" edit="/1/@proposals.0/@proposals.1/@attempts.36/@edit" start="2670" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2624" charEnd="2626" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2685" charEnd="2687" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969977565" sizeMeasure="103" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ing" edit="/1/@proposals.0/@proposals.1/@attempts.37/@edit" start="2297" end="-390"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2624" charEnd="2626" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2685" charEnd="2687" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487969994277" sizeMeasure="103" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ing" edit="/1/@proposals.0/@proposals.1/@attempts.38/@edit" start="2268" end="-419"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2685" charEnd="2687" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2624" charEnd="2626" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970001208" sizeMeasure="103" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.39/@edit" start="217" end="-2465"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2616" charEnd="2618" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2677" charEnd="2679" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970057261" sizeMeasure="104" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="\nFollowing: &quot; + Arrays.asList(following).toString() + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nFollowers: &quot; Arrays.asList(followers" edit="/1/@proposals.0/@proposals.1/@attempts.40/@edit" start="2253" end="-390"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2677" charEnd="2679" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2738" charEnd="2740" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="88" charStart="2416" charEnd="2422" severity="2" problemCategory="20" problemType="1610612968"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="88" charStart="2423" charEnd="2429" severity="2" problemCategory="50" problemType="67108964"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970062681" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="+" edit="/1/@proposals.0/@proposals.1/@attempts.41/@edit" start="2329" end="-414"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2679" charEnd="2681" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2740" charEnd="2742" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970097312" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="private " edit="/1/@proposals.0/@proposals.1/@attempts.42/@edit" start="217" end="-2527"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2748" charEnd="2750" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2687" charEnd="2689" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970126135" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.43/@edit" start="2322" end="-373"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2630" charEnd="2632" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2691" charEnd="2693" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970152300" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="\nFollowers: &quot; + &quot;]" edit="/1/@proposals.0/@proposals.1/@attempts.44/@edit" start="2322" end="-373"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2649" charEnd="2651" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2710" charEnd="2712" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970177781" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="followers" edit="/1/@proposals.0/@proposals.1/@attempts.45/@edit" start="2339" end="-378"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2661" charEnd="2663" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2722" charEnd="2724" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970208998" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Arrays.asList(followers).toString() + &quot;]\n" edit="/1/@proposals.0/@proposals.1/@attempts.46/@edit" start="2339" end="-373"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2689" charEnd="2691" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2750" charEnd="2752" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970224650" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers).toString() + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nFollowers: &quot; +" edit="/1/@proposals.0/@proposals.1/@attempts.47/@edit" start="2298" end="-377"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2711" charEnd="2713" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2650" charEnd="2652" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970271805" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ers: &quot; + Arrays.asList(followers).toString() + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nFollowing: &quot; + Arrays.asList(following).toString() + " edit="/1/@proposals.0/@proposals.1/@attempts.48/@edit" start="2269" end="-377"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2689" charEnd="2691" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2750" charEnd="2752" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970278887" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.49/@edit" start="2339" end="-378"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2652" charEnd="2654" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2713" charEnd="2715" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970315515" sizeMeasure="104" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="TwitterAccount: &quot; + userName + &quot;\nFollowing: &quot; + Arrays.asList(following).toString() + &#xA;&#x9;&#x9;&#x9;&#x9;&quot;\nFollowers: &quot; + Arrays.asList(followers).toString() + &quot;" edit="/1/@proposals.0/@proposals.1/@attempts.50/@edit" start="2228" end="-375"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2687" charEnd="2689" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="96" charStart="2748" charEnd="2750" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970353787" sizeMeasure="103" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.51/@edit" start="2256" end="-372"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="81" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2562" charEnd="2564" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2623" charEnd="2625" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970367227" sizeMeasure="103" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".isFollowing(Johannes)" edit="/1/@proposals.0/@proposals.1/@attempts.52/@edit" start="2612" end="-16"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="81" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2562" charEnd="2564" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2623" charEnd="2625" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970381592" sizeMeasure="104" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(Johannes.isFollowing(Lise" edit="/1/@proposals.0/@proposals.1/@attempts.53/@edit" start="2639" end="-17"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2623" charEnd="2625" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="81" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2562" charEnd="2564" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970395423" sizeMeasure="105" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="System.out.println(Johannes.isFollowedBy" edit="/1/@proposals.0/@proposals.1/@attempts.54/@edit" start="2689" end="-22"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="81" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2562" charEnd="2564" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2623" charEnd="2625" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970410599" sizeMeasure="106" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Lise.isFollowedBy(Johannes" edit="/1/@proposals.0/@proposals.1/@attempts.55/@edit" start="2708" end="-68"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2562" charEnd="2564" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2623" charEnd="2625" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="81" severity="1" problemCategory="120" problemType="268435844"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970442476" sizeMeasure="113" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Lise.un" edit="/1/@proposals.0/@proposals.1/@attempts.56/@edit" start="2794" end="-236"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="4" charStart="65" charEnd="81" severity="1" problemCategory="120" problemType="268435844"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2562" charEnd="2564" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="95" charStart="2623" charEnd="2625" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970464527" sizeMeasure="112" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.57/@edit" start="72" end="-2959"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="93" charStart="2536" charEnd="2538" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2597" charEnd="2599" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970620319" sizeMeasure="112" errorCount="1" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="List;&#xA;&#xA;public class TwitterAccount {&#xA;&#x9;&#xA;&#x9;private String userName;&#xA;&#x9;private List&lt;Tweet> tweets = new ArrayList&lt;Tweet>();&#xA;&#x9;private List&lt;TwitterAccount> followers = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;private List&lt;TwitterAccount> following = new ArrayList&lt;TwitterAccount>();&#xA;&#x9;&#xA;&#x9;public TwitterAccount (String userName) {&#xA;&#x9;&#x9;this.userName = userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getUserName() { //Done&#xA;&#x9;&#x9;// Return username&#xA;&#x9;&#x9;return userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void follow(TwitterAccount account){ //Not Done&#xA;&#x9;&#x9;// Start following account if not already following, and not itself&#xA;&#x9;&#x9;if (account != this &amp;&amp; !following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.add(account);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (!account.isFollowedBy(this)) {&#xA;&#x9;&#x9;&#x9;account.followers.add(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void unfollow(TwitterAccount account) {&#xA;&#x9;&#x9;// Stop following account if following&#xA;&#x9;&#x9;if (following.contains(account)) {&#xA;&#x9;&#x9;&#x9;following.remove(account);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;if (account.isFollowedBy(this)) {&#xA;&#x9;&#x9;&#x9;account.followers.remove(this);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowing(TwitterAccount account) { //Done&#xA;&#x9;&#x9;// True if following account, false if not following&#xA;&#x9;&#x9;return following.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isFollowedBy(TwitterAccount account)  { //Done&#xA;&#x9;&#x9;// True if followed by account, false if not followed by account&#xA;&#x9;&#x9;return followers.contains(account);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void tweet(String tweetText) { // Done&#xA;&#x9;&#x9;// Create new tweet&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, &quot;tweetText&quot;));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void retweet(Tweet tweet) { //Done&#xA;&#x9;&#x9;// Retweeting a tweet if it is not your own tweet (checking this in Tweet, no need to check it here)&#xA;&#x9;&#x9;tweets.add(0, new Tweet(this, tweet));&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public Tweet getTweet(int i) { //Done&#xA;&#x9;&#x9;// Return tweet #i, 1 is newest tweet, 2 is second newest etc, &#xA;&#x9;&#x9;if (i > 0 &amp;&amp; i &lt; getTweetCount()) {&#xA;&#x9;&#x9;&#x9;return tweets.get(i-1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;throw IllegalArgumentException(&quot;This account does not have that many tweets&quot;)" edit="/1/@proposals.0/@proposals.1/@attempts.58/@edit" start="72" end="-1146"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="67" charStart="1927" charEnd="1951" severity="2" problemCategory="50" problemType="67108964"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="93" charStart="2602" charEnd="2604" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2663" charEnd="2665" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487970625083" sizeMeasure="112" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ne" edit="/1/@proposals.0/@proposals.1/@attempts.59/@edit" start="1861" end="-1219"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="93" charStart="2606" charEnd="2608" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2667" charEnd="2669" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487971106967" sizeMeasure="113" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//&#x9;&#x9;Lise.follow(Johannes);&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowing(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowing(Lise));&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowedBy(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowedBy(Lise));&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;Lise.unfollow(Johannes);&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowing(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowing(Lise));&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowedBy(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowedBy(Lise));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;System.out.println(t1);" edit="/1/@proposals.0/@proposals.1/@attempts.60/@edit" start="2604" end="-11"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="93" charStart="2606" charEnd="2608" severity="1" problemCategory="120" problemType="536870973"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="94" charStart="2667" charEnd="2669" severity="1" problemCategory="120" problemType="536870973"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487971222413" sizeMeasure="115" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="itterAccount LM = new TwitterAccount(&quot;LM&quot;);&#xA;&#x9;&#x9;Lise.tweet(&quot;Heisann jeg tvitrer&quot;);&#xA;&#x9;&#x9;Johannes.tweet(&quot;Jeg ror&quot;);&#xA;&#x9;&#x9;LM.tweet(&quot;Jeg drikker alko&quot;);&#xA;&#x9;&#x9;Lise.retweet(LM.getTweet(1)" edit="/1/@proposals.0/@proposals.1/@attempts.61/@edit" start="2466" end="-533"/>
          <markers xsi:type="jdt:JdtMarkerInfo" lineNumber="111" charStart="3265" charEnd="3267" severity="2" problemCategory="50" problemType="33554515"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487971239297" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.62/@edit" start="3136" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487971258420" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="= getTweetCount()) {&#xA;&#x9;&#x9;&#x9;return tweets.get(i-1);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;throw new IllegalArgumentException(&quot;This account does not have that many tweets&quot;);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getTweetCount() { //Done&#xA;&#x9;&#x9;// Return tweetcount&#xA;&#x9;&#x9;return tweets.size();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public int getRetweetCount() { //Done&#xA;&#x9;&#x9;// Return #retweets from account combined&#xA;&#x9;&#x9;int count = 0;&#xA;&#x9;&#x9;for (Tweet t : tweets) {&#xA;&#x9;&#x9;&#x9;count += t.getRetweetCount();&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;return count;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public String toString() { //Done&#xA;&#x9;&#x9;return &quot;TwitterAccount: &quot; + userName;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;TwitterAccount Lise = new TwitterAccount(&quot;Lise&quot;);&#xA;&#x9;&#x9;TwitterAccount Johannes = new TwitterAccount(&quot;Johannes&quot;);&#xA;&#x9;&#x9;TwitterAccount LM = new TwitterAccount(&quot;LM&quot;);&#xA;&#x9;&#x9;Lise.tweet(&quot;Heisann jeg tvitrer&quot;);&#xA;&#x9;&#x9;Johannes.tweet(&quot;Jeg ror&quot;);&#xA;&#x9;&#x9;LM.tweet(&quot;Jeg drikker alko&quot;);&#xA;&#x9;&#x9;Lise.retweet(LM.getTweet(1));&#xA;//&#x9;&#x9;Lise.follow(Johannes);&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowing(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowing(Lise));&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowedBy(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowedBy(Lise));&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;Lise.unfollow(Johannes);&#xA;//&#x9;&#x9;&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowing(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowing(Lise));&#xA;//&#x9;&#x9;System.out.println(Lise.isFollowedBy(Johannes));&#xA;//&#x9;&#x9;System.out.println(Johannes.isFollowedBy(Lise));" edit="/1/@proposals.0/@proposals.1/@attempts.63/@edit" start="1802" end="-14"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487971286838" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="tweetText" edit="/1/@proposals.0/@proposals.1/@attempts.64/@edit" start="1467" end="-1667"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1487972062939" sizeMeasure="114">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" //Not Done" edit="/1/@proposals.0/@proposals.1/@attempts.65/@edit" start="841" end="-2302"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487966984001" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487966995425" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967136734" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967147234" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967278276" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967309322" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967319732" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967419017" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967535583" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967545055" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967567891" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487967620646" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487969809001" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487969845361" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487969861882" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487969952913" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487969978839" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970002355" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970063708" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970098886" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970131151" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970155162" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970178840" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970225804" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970272931" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970280165" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970315470" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970355149" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970368429" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970381544" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970395378" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970411619" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487970443695" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487971106919" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487971227171" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487971240338" mode="run"/>
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1487971259471" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.4/@q" answer="/0/@parts.0/@tasks.4/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487966832520" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487967660390" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487970925970" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487970992348" completion="1.0" successCount="4">
          <successTests>testGetRetweetCount</successTests>
          <successTests>testGetOriginalTweet</successTests>
          <successTests>testConstructorNewTweet</successTests>
          <successTests>testConstructorRetweet</successTests>
        </attempts>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.5/@q" answer="/0/@parts.0/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487970547438" completion="0.5" successCount="3" failureCount="1" errorCount="2">
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testGetTweetIllegal</failureTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487970628275" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487970910734" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487970931527" completion="0.6666666666666666" successCount="4" errorCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <errorTests>testRetweet</errorTests>
          <errorTests>testNewTweet</errorTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487971263451" completion="0.6666666666666666" successCount="4" failureCount="2">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <failureTests>testRetweet</failureTests>
          <failureTests>testNewTweet</failureTests>
        </attempts>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1487971288686" completion="1.0" successCount="6">
          <successTests>testGetTweetIllegal</successTests>
          <successTests>testUnfollow</successTests>
          <successTests>testRetweet</successTests>
          <successTests>testFollow</successTests>
          <successTests>testConstructor</successTests>
          <successTests>testNewTweet</successTests>
        </attempts>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a"/>
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
