<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Logger">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the ILogger Interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.ILogger"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Implementations">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StreamLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StreamLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.StreamLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StreamLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.StreamLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the FilteringLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the FilteringLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.FilteringLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the FilteringLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.FilteringLoggerTest"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the DistributingLogger Class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the DistributingLogger class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.delegation.DistributingLogger"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the DistributingLogger JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.delegation.DistributingLoggerTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.delegation.*Logger" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772365611" sizeMeasure="36">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.io.OutputStream;&#xA;import java.io.PrintWriter;&#xA;&#xA;public class StreamLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private static final String DEFAULT_FORMAT = &quot;[%s] %s&quot;;&#xA;&#xA;&#x9;private final PrintWriter mWriter;&#xA;&#x9;private String mFormat = DEFAULT_FORMAT;&#xA;&#x9;&#xA;&#x9;public StreamLogger(OutputStream out) {&#xA;&#x9;&#x9;if (out == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();&#xA;&#x9;&#x9;mWriter = new PrintWriter(out);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;if (severity == null || message == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();&#xA;&#x9;&#x9;String line = String.format(mFormat, severity, message);&#xA;&#x9;&#x9;mWriter.println(line);&#xA;&#x9;&#x9;if (exception != null)&#xA;&#x9;&#x9;&#x9;exception.printStackTrace(mWriter);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setFormatString(String format) {&#xA;&#x9;&#x9;if (format == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();&#xA;&#x9;&#x9;// Validate format before setting&#xA;&#x9;&#x9;String.format(format, &quot;a&quot;, &quot;b&quot;);&#xA;&#x9;&#x9;mFormat = format;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772462629" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;&#x9;System.out.println(format" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="833" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772493333" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="836" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772494118" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="833" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772502408" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#x9;// Validate format before setting&#xA;&#x9;&#x9;String.format(format, &quot;a&quot;, &quot;b&quot;, null" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="833" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772522785" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;c&quot;" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="903" end="-29"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772554404" sizeMeasure="37" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="exceptionMessage = exception != null ? exception.getLocalizedMessage() : null" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="584" end="-362"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772558801" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=", exceptionM" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="719" end="-310"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772570621" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" (%s)" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="191" end="-850"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772578183" sizeMeasure="37">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private static final String DEFAULT_FORMAT = &quot;[%s] %s (%s)&quot;;&#xA;&#xA;&#x9;private final PrintWriter mWriter;&#xA;&#x9;private String mFormat = DEFAULT_FORMAT;&#xA;&#xA;&#x9;public StreamLogger(OutputStream out) {&#xA;&#x9;&#x9;if (out == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();&#xA;&#x9;&#x9;mWriter = new PrintWriter(out);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;if (severity == null || message == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();&#xA;&#x9;&#x9;String exceptionMessage = exception != null ? exception.getLocalizedMessage() : null;&#xA;&#x9;&#x9;String line = String.format(mFormat, severity, message, exceptionMessage);&#xA;&#x9;&#x9;mWriter.println(line);&#xA;&#x9;&#x9;if (exception != null)&#xA;&#x9;&#x9;&#x9;exception.printStackTrace(mWriter);&#xA;&#x9;}&#xA;" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="135" end="-208"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772609514" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;System.out.println(line" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="832" end="-214"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772750293" sizeMeasure="38">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=" // XXX" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="858" end="-212"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772772387" sizeMeasure="39">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mWriter.flush(" edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="833" end="-249"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772865014" sizeMeasure="36">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="line = String.format(mFormat, severity, message, exception);&#xA;&#x9;&#x9;mWriter.println(line" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="586" end="-268"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772872939" sizeMeasure="35">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="692" end="-212"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490772373078" completion="0.0" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490772466967" completion="0.0" failureCount="1" errorCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490772581748" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490772616930" completion="0.0" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490772808483" completion="0.3333333333333333" successCount="1" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490772868627" completion="1.0" successCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490773570238" completion="1.0" successCount="3"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.3/@q" answer="/0/@parts.1/@tasks.3/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772961749" sizeMeasure="13" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;import java.util.HashSet;&#xA;&#xA;public class FilteringLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private final HashSet&lt;String> mSeverities = new HashSet&lt;>();&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490772976195" sizeMeasure="13" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.3/@attempts.0/@edit" start="264" end="-265"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773041459" sizeMeasure="20" errorCount="3" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="Collections;&#xA;import java.util.HashSet;&#xA;&#xA;public class FilteringLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private final HashSet&lt;String> mSeverities = new HashSet&lt;>();&#xA;&#x9;private final ILogger mDelegate;&#xA;&#x9;&#xA;&#x9;public FinteringLogger(ILogger delegate, String... severities) {&#xA;&#x9;&#x9;mDelegate = delegate;&#xA;&#x9;&#x9;Collections.addAll(mDelegate, severities);&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.3/@attempts.1/@edit" start="47" end="-95"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773081199" sizeMeasure="21" errorCount="2" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="for (String severity : severities)&#xA;&#x9;&#x9;&#x9;mSeverities.add(severity" edit="/1/@proposals.1/@proposals.3/@attempts.2/@edit" start="329" end="-100"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773110005" sizeMeasure="21" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="l" edit="/1/@proposals.1/@proposals.3/@attempts.3/@edit" start="247" end="-243"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773112383" sizeMeasure="20" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.3/@attempts.4/@edit" start="47" end="-432"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773137046" sizeMeasure="24" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="HashSet;&#xA;&#xA;public class FilteringLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private final HashSet&lt;String> mSeverities = new HashSet&lt;>();&#xA;&#x9;private final ILogger mDelegate;&#xA;&#x9;&#xA;&#x9;public FilteringLogger(ILogger delegate, String... severities) {&#xA;&#x9;&#x9;mDelegate = delegate;&#xA;&#x9;&#x9;for (String severity : severities)&#xA;&#x9;&#x9;&#x9;mSeverities.add(severity);&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public boolean isLogging(String severity) {&#xA;&#x9;&#x9;return mSeverities.contains(severity);" edit="/1/@proposals.1/@proposals.3/@attempts.5/@edit" start="47" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773153019" sizeMeasure="28" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;public void setIsLogging(String severity, boolean log) {&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.3/@attempts.6/@edit" start="549" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773188400" sizeMeasure="33" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (severity == null)&#xA;&#x9;&#x9;&#x9;return;&#xA;&#x9;&#x9;if (log)&#xA;&#x9;&#x9;&#x9;mSeverities.add(severity);&#xA;&#x9;&#x9;else&#xA;&#x9;&#x9;&#x9;mSeverities.remove(severity);" edit="/1/@proposals.1/@proposals.3/@attempts.7/@edit" start="611" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773217721" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (isLogging(severity))&#xA;&#x9;&#x9;&#x9;mDelegate.log(severity, message, exception);" edit="/1/@proposals.1/@proposals.3/@attempts.8/@edit" start="454" end="-277"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773423105" sizeMeasure="34">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="throw new NullPointerException()" edit="/1/@proposals.1/@proposals.3/@attempts.9/@edit" start="708" end="-89"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.4/@q" answer="/0/@parts.1/@tasks.4/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.5/@q" answer="/0/@parts.1/@tasks.5/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490773229559" completion="1.0" successCount="5"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490773566557" completion="1.0" successCount="5"/>
      </proposals>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.6/@q" answer="/0/@parts.1/@tasks.6/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773309366" sizeMeasure="14" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.delegation;&#xA;&#xA;public class DistributingLogger implements ILogger {&#xA;&#x9;&#xA;&#x9;private final ILogger mErrorLogger, mWarningLogger, mInfoLogger;&#xA;&#x9;&#xA;&#x9;public public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773327782" sizeMeasure="17" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;mErrorLogger = errorLogger;&#xA;&#x9;&#x9;mWarningLogger = warningLogger;&#xA;&#x9;&#x9;mInfoLogger = infoLogger;" edit="/1/@proposals.1/@proposals.6/@attempts.0/@edit" start="254" end="-98"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773340382" sizeMeasure="17" errorCount="1" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.6/@attempts.1/@edit" start="94" end="-343"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773347542" sizeMeasure="18" errorCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="ILogger mErrorLogger, mWarningLogger, mInfoLogger;&#xA;&#x9;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;if ()" edit="/1/@proposals.1/@proposals.6/@attempts.2/@edit" start="94" end="-190"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773364036" sizeMeasure="19" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="errorLogger == null || warningLogger == null || infoLogger == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();" edit="/1/@proposals.1/@proposals.6/@attempts.3/@edit" start="246" end="-190"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773408027" sizeMeasure="22" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="mErrorLogger = errorLogger;&#xA;&#x9;&#x9;mWarningLogger = warningLogger;&#xA;&#x9;&#x9;mInfoLogger = infoLogger;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setLogger(String severity, ILogger logger) {&#xA;&#x9;&#x9;if (severity == null)&#xA;&#x9;&#x9;&#x9;throw new NullPointerException();" edit="/1/@proposals.1/@proposals.6/@attempts.4/@edit" start="242" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773495071" sizeMeasure="35" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;switch (severity) {&#xA;&#x9;&#x9;case ERROR:&#xA;&#x9;&#x9;&#x9;mErrorLogger = logger;&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case WARNING:&#xA;&#x9;&#x9;&#x9;mWarningLogger = logger;&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case INFO:&#xA;&#x9;&#x9;&#x9;mInfoLogger = logger;&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;default:&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException();&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.5/@edit" start="548" end="-7"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773501875" sizeMeasure="35" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&quot;Invalid severity&quot;" edit="/1/@proposals.1/@proposals.6/@attempts.6/@edit" start="770" end="-13"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773509686" sizeMeasure="47" errorCount="3" warningCount="3">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="switch (severity) {&#xA;&#x9;&#x9;case ERROR:&#xA;&#x9;&#x9;&#x9;mErrorLogger = logger;&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case WARNING:&#xA;&#x9;&#x9;&#x9;mWarningLogger = logger;&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case INFO:&#xA;&#x9;&#x9;&#x9;mInfoLogger = logger;&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;default:&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid severity&quot;);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.6/@attempts.7/@edit" start="422" end="-379"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773528721" sizeMeasure="48" errorCount="2" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (mErrorLogger != null)&#xA;&#x9;&#x9;&#x9;&#x9;mErrorLogger.log(severity, message, exception)" edit="/1/@proposals.1/@proposals.6/@attempts.8/@edit" start="459" end="-566"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773540527" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if (mWarningLogger != null)&#xA;&#x9;&#x9;&#x9;&#x9;mWarningLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case INFO:&#xA;&#x9;&#x9;&#x9;if (mInfoLogger != null)&#xA;&#x9;&#x9;&#x9;&#x9;mInfoLogger.log(severity, message, exception)" edit="/1/@proposals.1/@proposals.6/@attempts.9/@edit" start="566" end="-464"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490773544249" sizeMeasure="50">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#xA;&#x9;private ILogger mErrorLogger, mWarningLogger, mInfoLogger;&#xA;&#xA;&#x9;public DistributingLogger(ILogger errorLogger, ILogger warningLogger, ILogger infoLogger) {&#xA;&#x9;&#x9;mErrorLogger = errorLogger;&#xA;&#x9;&#x9;mWarningLogger = warningLogger;&#xA;&#x9;&#x9;mInfoLogger = infoLogger;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void log(String severity, String message, Exception exception) {&#xA;&#x9;&#x9;switch (severity) {&#xA;&#x9;&#x9;case ERROR:&#xA;&#x9;&#x9;&#x9;if (mErrorLogger != null)&#xA;&#x9;&#x9;&#x9;&#x9;mErrorLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case WARNING:&#xA;&#x9;&#x9;&#x9;if (mWarningLogger != null)&#xA;&#x9;&#x9;&#x9;&#x9;mWarningLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;case INFO:&#xA;&#x9;&#x9;&#x9;if (mInfoLogger != null)&#xA;&#x9;&#x9;&#x9;&#x9;mInfoLogger.log(severity, message, exception);&#xA;&#x9;&#x9;&#x9;break;&#xA;&#x9;&#x9;default:&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Invalid severity&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;" edit="/1/@proposals.1/@proposals.6/@attempts.10/@edit" start="83" end="-374"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.7/@q" answer="/0/@parts.1/@tasks.7/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.8/@q" answer="/0/@parts.1/@tasks.8/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490773562862" completion="1.0" successCount="4"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.2/@tasks.3/@q" answer="/0/@parts.2/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
