<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490181509269" sizeMeasure="64">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;//void addStockListener(StockListener) - metode for å legge til nye observatører.&#xA;//void removeStockListener(StockListener) - metode for å fjerne observatører.&#xA;//Observatørene skal holdes oppdatert på prisendringer. Derfor må lyttermetoden kalles hos alle registrerte observatører når aksjeprisen endres med setPrice-metoden.&#xA;&#xA;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker; &#xA;&#x9;private double price;&#xA;&#x9;private List&lt;StockListener> stockListeners = new ArrayList&lt;StockListener>();&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price) {&#xA;&#x9;&#x9;super();&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;this.price = price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double newPrice) {&#xA;&#x9;&#x9;if (price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot; Illegal argument. The price has to be greater than 0.&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;double oldPrice = price;&#xA;&#x9;&#x9;price = newPrice;&#xA;&#x9;&#x9;for(StockListener stockListener : stockListeners ){&#xA;&#x9;&#x9;&#x9;stockListener.stockPriceChanged(this, oldPrice, price);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getPrice() {&#xA;&#x9;&#x9;return price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker() {&#xA;&#x9;&#x9;return ticker;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStockListener(StockListener stockListener){&#xA;&#x9;&#x9;if(!stockListeners.contains(stockListener)){&#xA;&#x9;&#x9;&#x9;stockListeners.add(stockListener);}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStockListener(StockListener stockListener){&#xA;&#x9;&#x9;if(stockListeners.contains(stockListener)){&#xA;&#x9;&#x9;&#x9;stockListeners.remove(stockListener);}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;public static void main(String[] args) {&#xA;&#x9;Stock s1 = new Stock(&quot;ABG&quot;, 100);&#xA;&#x9;s1.setPrice(0);&#xA;}&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182117223" sizeMeasure="54">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.0/@proposals.1/@attempts.0/@edit" start="1408" end="-4"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490173128512" sizeMeasure="64" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.List;&#xA;&#xA;//Vi skal nå lage en veldig forenklet versjon av en aksjeindeks. I korte trekk bruker man en aksjeindeks til å måle utviklingen av et utvalg aksjer. &#xA;//Vår enkle, fiktive aksjeindeks &#xA;//StockIndex har et navn (String), indeks (double) og en liste med Stock-objektene som er inkludert i indeksen. &#xA;&#xA;//Indeksen beregnes ut i fra summen av aksjeprisene den &quot;observerer&quot;.&#xA;//Når en av aksjeprisene øker eller synker, må tilstanden til StockIndex-objektet holdes konsistent med denne utviklingen. &#xA;//Dette lar seg gjøre ved at StockIndex observerer én eller flere Stock-objekter. Klassen skal ha følgende metoder:&#xA;//&#xA;//StockIndex(String, Stock... ) - konstruktør som tar inn ingen, én eller flere aksjer (Stock-objekter). &#xA;//Stock-parameteret defineres som et såkalt varargs-parameter.  &#xA;//NB: StockIndex-objektet skal holdes oppdatert på aksjeprisene allerede fra det er instansiert. &#xA;//Dersom en indeks instansieres uten Stock-objekter, skal aksjeindeksen være 0.&#xA;&#xA;//void addStock(Stock) - metode for å legge til en aksjepris i indeksen.&#xA;//void removeStock(Stock) - metode for å fjerne en aksjepris fra indeksen.&#xA;//double getIndex() - hentemetode for indeksen.&#xA;//I tillegg må StockIndex-klassen selvsagt implementere StockListener og dermed også lyttermetoden stockPriceChanged, slik at indeksen kan holdes oppdatert.&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String indexName;&#xA;&#x9;private double indexValue = 0;&#xA;&#x9;List&lt;Stock> index = new ArrayList&lt;Stock>();&#xA;&#x9;&#xA;&#x9;public StockIndex(String indexName, Stock...stocks){&#xA;&#x9;&#x9;if(!(stocks.length == 0)){&#xA;&#x9;&#x9;&#x9;for(Stock stock: stocks){&#xA;&#x9;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;&#x9;indexValue += stock.getPrice();&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;index.add(stock);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;index.remove(stock);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return indexValue;&#xA;&#x9;}&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;for(Stock s: index){&#xA;&#x9;&#x9;&#x9;if( s.equals(stock)){&#xA;&#x9;&#x9;&#x9;&#x9;s.setPrice(newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490173526107" sizeMeasure="63" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;&#xA;&#x9;&#xA;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;for(Stock s:index ){&#xA;&#x9;&#x9;&#x9;indexValue += s.getPrice();&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="1997" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490181574731" sizeMeasure="62" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="StockIndex har et navn (String), indeks (double) og en liste med Stock-objektene som er inkludert i indeksen. &#xA;&#xA;//Indeksen beregnes ut i fra summen av aksjeprisene den &quot;observerer&quot;.&#xA;//Når en av aksjeprisene øker eller synker, må tilstanden til StockIndex-objektet holdes konsistent med denne utviklingen. &#xA;//Dette lar seg gjøre ved at StockIndex observerer én eller flere Stock-objekter. Klassen skal ha følgende metoder:&#xA;//&#xA;//StockIndex(String, Stock... ) - konstruktør som tar inn ingen, én eller flere aksjer (Stock-objekter). &#xA;//Stock-parameteret defineres som et såkalt varargs-parameter.  &#xA;//NB: StockIndex-objektet skal holdes oppdatert på aksjeprisene allerede fra det er instansiert. &#xA;//Dersom en indeks instansieres uten Stock-objekter, skal aksjeindeksen være 0.&#xA;&#xA;//void addStock(Stock) - metode for å legge til en aksjepris i indeksen.&#xA;//void removeStock(Stock) - metode for å fjerne en aksjepris fra indeksen.&#xA;//double getIndex() - hentemetode for indeksen.&#xA;//I tillegg må StockIndex-klassen selvsagt implementere StockListener og dermed også lyttermetoden stockPriceChanged, slik at indeksen kan holdes oppdatert.&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String indexName;&#xA;&#x9;private double indexValue = 0;&#xA;&#x9;List&lt;Stock> index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String indexName, Stock...stocks){&#xA;&#x9;&#x9;index = new ArrayList&lt;Stock>();" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="84" end="-552"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490181637320" sizeMeasure="62" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=";&#xA;&#x9;List&lt;Stock> index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String indexName, Stock...stocks){&#xA;&#x9;&#x9;index = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;indexValue = 0;&#xA;&#x9;&#x9;for(Stock stock: stocks){&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;indexValue += stock.getPrice();&#xA;&#x9;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="1318" end="-419"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490181799509" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//StockIndex(String, Stock... ) - konstruktør som tar inn ingen, én eller flere aksjer (Stock-objekter). &#xA;//void addStock(Stock) - metode for å legge til en aksjepris i indeksen.&#xA;//void removeStock(Stock) - metode for å fjerne en aksjepris fra indeksen.&#xA;//double getIndex() - hentemetode for indeksen.&#xA;//I tillegg må StockIndex-klassen selvsagt implementere StockListener og dermed også lyttermetoden stockPriceChanged, slik at indeksen kan holdes oppdatert.&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String indexName;&#xA;&#x9;private double indexValue;&#xA;&#x9;List&lt;Stock> index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String indexName, Stock...stocks){&#xA;&#x9;&#x9;index = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;indexValue = 0;&#xA;&#x9;&#x9;for(Stock stock: stocks){&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;indexValue += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;if(!index.contains(stock)){&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;index.add(stock);&#xA;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.3/@edit" start="195" end="-322"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490181859049" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(index.contains(stock)){&#xA;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;index.remove(stock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return indexValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.4/@edit" start="1165" end="-159"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182112988" sizeMeasure="53" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="indexValue += newPrice - oldPrice;" edit="/1/@proposals.1/@proposals.0/@attempts.5/@edit" start="1407" end="-10"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182365984" sizeMeasure="54" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;indexValue -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.6/@edit" start="1194" end="-224"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182383434" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="indexValue += stock.getPrice();" edit="/1/@proposals.1/@proposals.0/@attempts.7/@edit" start="1064" end="-428"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182810135" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="//if(index.contains(stock)){&#xA;&#x9;&#x9;&#x9;indexValue -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;index.remove(stock);&#xA;&#x9;&#x9;//" edit="/1/@proposals.1/@proposals.0/@attempts.8/@edit" start="1200" end="-199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490182822110" sizeMeasure="55" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="if(index.contains(stock)){&#xA;&#x9;&#x9;&#x9;indexValue -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;index.remove(stock);&#xA;&#x9;&#x9;" edit="/1/@proposals.1/@proposals.0/@attempts.9/@edit" start="1200" end="-199"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183451512" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="&#x9;if(index.size() == 0){&#xA;&#x9;&#x9;&#x9;&#x9;indexValue = 0;&#xA;&#x9;&#x9;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.10/@edit" start="1324" end="-202"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183466620" sizeMeasure="58" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="." edit="/1/@proposals.1/@proposals.0/@attempts.11/@edit" start="1366" end="-209"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183716496" sizeMeasure="68" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return indexValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;indexValue += newPrice - oldPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;apple&quot;, 100);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;fb&quot;, 200);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;java&quot;, 50);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex OCS = new StockIndex(&quot;OCS&quot;, s1,s2,s3);&#xA;&#x9;&#x9;OCS.removeStock(s1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;OCS.removeStock(s1);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;&#xA;&#x9;}" edit="/1/@proposals.1/@proposals.0/@attempts.12/@edit" start="1324" end="-4"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183798673" sizeMeasure="73" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="import java.util.Stack;&#xA;&#xA;//StockIndex har et navn (String), indeks (double) og en liste med Stock-objektene som er inkludert i indeksen. &#xA;//StockIndex(String, Stock... ) - konstruktør som tar inn ingen, én eller flere aksjer (Stock-objekter). &#xA;//void addStock(Stock) - metode for å legge til en aksjepris i indeksen.&#xA;//void removeStock(Stock) - metode for å fjerne en aksjepris fra indeksen.&#xA;//double getIndex() - hentemetode for indeksen.&#xA;//I tillegg må StockIndex-klassen selvsagt implementere StockListener og dermed også lyttermetoden stockPriceChanged, slik at indeksen kan holdes oppdatert.&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#x9;&#xA;&#x9;private String indexName;&#xA;&#x9;private double indexValue;&#xA;&#x9;List&lt;Stock> index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String indexName, Stock...stocks){&#xA;&#x9;&#x9;index = new ArrayList&lt;Stock>();&#xA;&#x9;&#x9;indexValue = 0;&#xA;&#x9;&#x9;for(Stock stock: stocks){&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;indexValue += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;if(!index.contains(stock)){&#xA;&#x9;&#x9;&#x9;indexValue += stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;index.add(stock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;if(index.contains(stock)){&#xA;&#x9;&#x9;&#x9;indexValue -= stock.getPrice();&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;index.remove(stock);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return indexValue;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;indexValue += newPrice - oldPrice;&#xA;&#x9;}&#xA;&#x9;&#xA;&#xA;&#x9;public static void main(String[] args) {&#xA;&#x9;&#x9;Stock s1 = new Stock(&quot;apple&quot;, 100);&#xA;&#x9;&#x9;Stock s2 = new Stock(&quot;fb&quot;, 200);&#xA;&#x9;&#x9;Stock s3 = new Stock(&quot;java&quot;, 50);&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;StockIndex OCS = new StockIndex(&quot;OCS&quot;, s1,s2,s3);&#xA;&#x9;&#x9;System.out.println(OCS.getIndex());&#xA;&#x9;&#x9;OCS.removeStock(s1);&#xA;&#x9;&#x9;System.out.println(OCS.getIndex());&#xA;&#x9;&#x9;OCS.removeStock(s1);&#xA;&#x9;&#x9;System.out.println(OCS.getIndex());&#xA;&#x9;&#x9;OCS.addStock(new Stock(&quot;microsoft&quot;, 10000));&#xA;&#x9;&#x9;System.out.println(OCS" edit="/1/@proposals.1/@proposals.0/@attempts.13/@edit" start="81" end="-18"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490183905260" sizeMeasure="74" warningCount="2">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString=".add(stock" edit="/1/@proposals.1/@proposals.0/@attempts.14/@edit" start="983" end="-1027"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtLaunchEvent" timestamp="1490183798611" mode="run"/>
      </proposals>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="0.75">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490173537814" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490182129081" completion="0.5" successCount="2" failureCount="2"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490182389446" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490182811459" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490182823556" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490183457372" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490183468343" completion="0.75" successCount="3" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
