<?xml version="1.0" encoding="UTF-8"?>
<xmi:XMI xmi:version="2.0" xmlns:xmi="http://www.omg.org/XMI" xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:exercise="platform:/plugin/no.hal.learning.exercise.model/model/exercise.ecore" xmlns:jdt="platform:/plugin/no.hal.learning.exercise.jdt/model/jdt-exercise.ecore" xmlns:junit="platform:/plugin/no.hal.learning.exercise.junit/model/junit-exercise.ecore" xmlns:workbench="platform:/plugin/no.hal.learning.exercise.workbench/model/workbench-exercise.ecore">
  <exercise:Exercise>
    <parts xsi:type="exercise:ExercisePart" title="Stock class and StockListener interface">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockListener interface."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockListener"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the Stock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the Stock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.Stock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the Stock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="StockIndex implements StockListener">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the StockIndex class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the StockIndex class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.StockIndex"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the StockIndex JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.StockIndexTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Extra assignments">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Write source code for the SmartStock class."/>
        <a xsi:type="jdt:JdtSourceEditAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Test the SmartStock class, by running its main method."/>
        <a xsi:type="jdt:JdtLaunchAnswer" className="patterns.observable.SmartStock"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Run the SmartStock JUnit test."/>
        <a xsi:type="junit:JunitTestAnswer" testRunName="patterns.observable.SmartStockTest"/>
      </tasks>
    </parts>
    <parts xsi:type="exercise:ExercisePart" title="Tool usage">
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use breakpoints to debug code."/>
        <a xsi:type="workbench:DebugEventAnswer" elementId="patterns.observable.*Stock*" action="suspend.breakpoint"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Over"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepOver" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the debug command Step Into"/>
        <a xsi:type="workbench:CommandExecutionAnswer" elementId="org.eclipse.debug.ui.commands.StepInto" action="executeSuccess"/>
      </tasks>
      <tasks xsi:type="exercise:Task">
        <q xsi:type="exercise:StringQuestion" question="Use the Variables view"/>
        <a xsi:type="workbench:PartTaskAnswer" elementId="org.eclipse.debug.ui.VariableView" action="activated"/>
      </tasks>
    </parts>
  </exercise:Exercise>
  <exercise:ExerciseProposals exercise="/0">
    <proposals exercisePart="/0/@parts.0">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.0/@q" answer="/0/@parts.0/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.0/@tasks.1/@q" answer="/0/@parts.0/@tasks.1/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490756598986" sizeMeasure="68">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.HashMap;&#xA;&#xA;public class Stock {&#xA;&#x9;&#xA;&#x9;private String ticker;&#xA;&#x9;private double price;&#xA;&#x9;private HashMap&lt;StockListener, ArrayList&lt;Double>> listenerDictionary;&#xA;&#x9;&#xA;&#x9;public Stock(String ticker, double price){&#xA;&#x9;&#x9;this.ticker = ticker;&#xA;&#x9;&#x9;if(price &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Stock price must be positive and higher than zero&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;this.price = price;&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;this.listenerDictionary = new HashMap&lt;StockListener, ArrayList&lt;Double>>();&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void setPrice(double priceSet){&#xA;&#x9;&#x9;if(priceSet &lt;= 0){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;New price must be higher than 0&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;updateListeners(priceSet);&#xA;&#x9;&#x9;this.price = priceSet;&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public String getTicker(){&#xA;&#x9;&#x9;return this.ticker;&#xA;&#x9;}&#xA;&#x9;public double getPrice(){&#xA;&#x9;&#x9;return this.price;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;void addStockListener(StockListener listener){&#xA;&#x9;&#x9;if(listenerDictionary.containsKey(listener)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;Listener is already registered!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;else{&#xA;&#x9;&#x9;&#x9;//kan bruke .put() siden vi vet at keyen ikke allerede eksisterer i hashmapet.&#xA;&#x9;&#x9;&#x9;listenerDictionary.put(listener, null);&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;void removeStockListener(StockListener listener){&#xA;&#x9;&#x9;if(!listenerDictionary.containsKey(listener)){&#xA;&#x9;&#x9;&#x9;throw new IllegalArgumentException(&quot;A listener by that name is not registered!&quot;);&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;listenerDictionary.remove(listener);&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;private void updateListeners(double newPrice) {&#xA;&#x9;&#x9;for (StockListener listener : listenerDictionary.keySet()) { &#xA;&#x9;&#x9;&#x9;if (listenerDictionary.get(listener) == null) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price, newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;&#x9;else if (newPrice &lt; listenerDictionary.get(listener).get(0) || newPrice > listenerDictionary.get(listener).get(1)) {&#xA;&#x9;&#x9;&#x9;&#x9;listener.stockPriceChanged(this, this.price, newPrice);&#xA;&#x9;&#x9;&#x9;}&#xA;&#x9;&#x9;}&#xA;&#x9;&#x9;//glemte å ha åpen .ex-fila IGJEN. &#xA;&#x9;&#x9;//skal jeg da begynne fra scratch og retrace stepsene mine &#xA;&#x9;&#x9;//og late som om jeg gjør feil?&#xA;}&#xA;}&#xA;"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.0/@tasks.2/@q" answer="/0/@parts.0/@tasks.2/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.0/@tasks.3/@q" answer="/0/@parts.0/@tasks.3/@a" completion="1.0">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490756612162" completion="1.0" successCount="2"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.1">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.1/@tasks.0/@q" answer="/0/@parts.1/@tasks.0/@a">
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490756670046" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:StringEdit" storedString="package patterns.observable;&#xA;&#xA;import java.util.ArrayList;&#xA;import java.util.Arrays;&#xA;&#xA;public class StockIndex implements StockListener{&#xA;&#xA;&#x9;//local variables&#xA;&#x9;private String name;&#xA;&#x9;private ArrayList&lt;Stock> stocks;&#xA;&#x9;private double index;&#xA;&#x9;&#xA;&#x9;public StockIndex(String name, Stock...stocks){&#xA;&#x9;&#x9;this.name = name;&#xA;&#x9;&#x9;this.stocks = new ArrayList&lt;Stock>(Arrays.asList(stocks));&#xA;&#x9;&#x9;&#xA;&#x9;&#x9;for(Stock stock : stocks){&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;this.index += stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;public void addStock(Stock stock){&#xA;&#x9;&#x9;if(!this.stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;this.stocks.add(stock);&#xA;&#x9;&#x9;&#x9;stock.addStockListener(this);&#xA;&#x9;&#x9;&#x9;this.index += stock.getPrice();&#x9;&#x9;&#x9;&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public void removeStock(Stock stock){&#xA;&#x9;&#x9;if(this.stocks.contains(stock)){&#xA;&#x9;&#x9;&#x9;stock.removeStockListener(this);&#xA;&#x9;&#x9;&#x9;this.stocks.remove(stock);&#xA;&#x9;&#x9;&#x9;this.index -= stock.getPrice();&#xA;&#x9;&#x9;}&#xA;&#x9;}&#xA;&#x9;public double getIndex(){&#xA;&#x9;&#x9;return this.index;&#xA;&#x9;}&#xA;&#x9;&#xA;&#x9;@Override&#xA;&#x9;public void stockPriceChanged(Stock stock, double oldPrice, double newPrice) {&#xA;&#x9;&#x9;// TODO Auto-generated method stub&#xA;&#x9;&#x9;&#xA;&#x9;}&#xA;&#xA;}&#xA;"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490756689948" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="haha wooops glemte å endre denne" edit="/1/@proposals.1/@proposals.0/@attempts.0/@edit" start="982" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490756709726" sizeMeasure="47" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" storedString="this.index += newPrice - oldPrice;" edit="/1/@proposals.1/@proposals.0/@attempts.1/@edit" start="979" end="-11"/>
        </attempts>
        <attempts xsi:type="jdt:JdtSourceEditEvent" timestamp="1490756713757" sizeMeasure="46" warningCount="1">
          <edit xsi:type="exercise:ReplaceSubstringEdit" edit="/1/@proposals.1/@proposals.0/@attempts.2/@edit" start="1015" end="-8"/>
        </attempts>
      </proposals>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.1/@tasks.1/@q" answer="/0/@parts.1/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.1/@tasks.2/@q" answer="/0/@parts.1/@tasks.2/@a" completion="0.75">
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490756513861" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490756624418" completion="0.25" successCount="1" failureCount="3"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490756673742" completion="0.75" successCount="3" failureCount="1"/>
        <attempts xsi:type="junit:JunitTestEvent" timestamp="1490756694832" completion="0.75" successCount="3" failureCount="1"/>
      </proposals>
    </proposals>
    <proposals exercisePart="/0/@parts.2">
      <proposals xsi:type="jdt:JdtSourceEditProposal" question="/0/@parts.2/@tasks.0/@q" answer="/0/@parts.2/@tasks.0/@a"/>
      <proposals xsi:type="jdt:JdtLaunchProposal" question="/0/@parts.2/@tasks.1/@q" answer="/0/@parts.2/@tasks.1/@a"/>
      <proposals xsi:type="junit:JunitTestProposal" question="/0/@parts.2/@tasks.2/@q" answer="/0/@parts.2/@tasks.2/@a"/>
    </proposals>
    <proposals exercisePart="/0/@parts.3">
      <proposals xsi:type="workbench:DebugEventProposal" question="/0/@parts.3/@tasks.0/@q" answer="/0/@parts.3/@tasks.0/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.1/@q" answer="/0/@parts.3/@tasks.1/@a"/>
      <proposals xsi:type="workbench:CommandExecutionProposal" question="/0/@parts.3/@tasks.2/@q" answer="/0/@parts.3/@tasks.2/@a"/>
      <proposals xsi:type="workbench:PartTaskProposal" question="/0/@parts.3/@tasks.3/@q" answer="/0/@parts.3/@tasks.3/@a"/>
    </proposals>
  </exercise:ExerciseProposals>
</xmi:XMI>
