package file.handling;

import java.io.File;
import java.util.ArrayList;
import java.util.List;


public class FilteredSolutionPathGenerator {
	private List<String> studentPackageNameList = new ArrayList<>();
	public List<String> solutionFileNameList = new ArrayList<>();
	private List<String> tempSolutionFileNameList = new ArrayList<>();
	private String solutionBasePath;
	
	public FilteredSolutionPathGenerator(List<String> studentPackageNameList, String solutionBasePath) {
		this.studentPackageNameList = studentPackageNameList;
		this.solutionBasePath = solutionBasePath;
		generateNameLists();
		createFilteredSolutionList();
	}

	private void generateNameLists() {
        File solutionProjectDir = new File(solutionBasePath);
        SolutionPathGenerator solutionPathGenerator = new SolutionPathGenerator(solutionProjectDir); 
        tempSolutionFileNameList = solutionPathGenerator.pathList;
               
	}

	private void createFilteredSolutionList() {
		for (String solutionPath: tempSolutionFileNameList) {
			for(String studentPath: studentPackageNameList){
				String[] solutionPathSplit = solutionPath.split("/");
				String[] studentPathSplit = studentPath.toString().split("\\.");
				//Solution
				String solutionClassName = (solutionPathSplit[solutionPathSplit.length-1].replace(".java", ""));
				String solutionPackageName = (solutionPathSplit[solutionPathSplit.length-2].replace(".java", ""));
				
				//Student code
				String studentClassName = (studentPathSplit[studentPathSplit.length-1]);
				String studentPackageName = (studentPathSplit[studentPathSplit.length-2]);
				
				//TODO: might have to change it to only check the packages. 
				if (solutionPackageName.equals(studentPackageName) && solutionClassName.equals(studentClassName)) {
					solutionFileNameList.add(solutionPath);
				}
			}
		}
	}
	
	
	
}
