package file.handling;

import java.util.ArrayList;
import java.util.List;

import org.eclipse.emf.common.util.TreeIterator;
import org.eclipse.emf.common.util.URI;
import org.eclipse.emf.ecore.EObject;
import org.eclipse.emf.ecore.EcorePackage;
import org.eclipse.emf.ecore.resource.Resource;
import org.eclipse.emf.ecore.resource.ResourceSet;
import org.eclipse.emf.ecore.resource.impl.ResourceSetImpl;
import no.hal.learning.exercise.ExercisePackage;
import no.hal.learning.exercise.impl.StringEditImpl;
import no.hal.learning.exercise.jdt.JdtPackage;
import no.hal.learning.exercise.jdt.JdtSourceEditEvent;
import no.hal.learning.exercise.junit.JunitPackage;
import no.hal.learning.exercise.util.ExerciseResourceFactoryImpl;
import no.hal.learning.exercise.workbench.WorkbenchPackage;
import no.hal.learning.exercise.workspace.WorkspacePackage;

public class GetStudentCodeSource {
	private List<String> fileNameList;
	public List<String> studentCodeList = new ArrayList<String>();
	public List<String> studentCodePackageNameList = new ArrayList<String>();
	private String filePathBase;
	
	public GetStudentCodeSource(List<String> fileNameList, String filePathBase) {
		this.fileNameList = fileNameList;
		this.filePathBase = filePathBase;
		getCode();
	}
	
	public void getCode() {
		
		List<String> codeStringEditImplList = new ArrayList<>();
		List<String> nameStringEditImplList = new ArrayList<>();
		ResourceSet resourceSet = new ResourceSetImpl();
		resourceSet.getPackageRegistry().put(EcorePackage.eNS_URI, EcorePackage.eINSTANCE);
		resourceSet.getPackageRegistry().put(ExercisePackage.eNS_URI, ExercisePackage.eINSTANCE);
		resourceSet.getPackageRegistry().put(JdtPackage.eNS_URI, JdtPackage.eINSTANCE);
		resourceSet.getPackageRegistry().put(JunitPackage.eNS_URI, JunitPackage.eINSTANCE);
		resourceSet.getPackageRegistry().put(WorkspacePackage.eNS_URI, WorkspacePackage.eINSTANCE);
		resourceSet.getPackageRegistry().put(WorkbenchPackage.eNS_URI, WorkbenchPackage.eINSTANCE);
		resourceSet.getResourceFactoryRegistry().getExtensionToFactoryMap().put("ex", new ExerciseResourceFactoryImpl());
		
		for(String fileName: fileNameList) {
			Resource resource = resourceSet.getResource(URI.createFileURI(filePathBase+fileName), true);
			TreeIterator<EObject> it = resource.getAllContents();
			while (it.hasNext()) {
				EObject eObject = it.next();	
				if (eObject instanceof JdtSourceEditEvent) {
					nameStringEditImplList.add(((JdtSourceEditEvent) eObject).getClassName());
				}
				if (eObject instanceof StringEditImpl) {
					String source = ((StringEditImpl) eObject).getString();
					int pos = source.lastIndexOf("package");
					if (pos >= source.length() / 2) {
						source = source.substring(0, pos);
						codeStringEditImplList.add(source);
					}
					else {
						codeStringEditImplList.add(source);
					}
					
				}
			}
			studentCodeList.add(codeStringEditImplList.get(codeStringEditImplList.size()-1));
			studentCodePackageNameList.add(nameStringEditImplList.get(nameStringEditImplList.size()-1));
			
		}
	}
}
