package file.handling;
import javax.xml.parsers.DocumentBuilderFactory;
import javax.xml.parsers.DocumentBuilder;
import org.w3c.dom.Document;
import org.w3c.dom.NodeList;

import list.printer.ListPrinter;

import org.w3c.dom.Node;
import org.w3c.dom.Element;
import java.io.File;
import java.util.ArrayList;
import java.util.Arrays;
import java.util.List;

public class ReadXMLFile {
	private String fileName;
	
	public String taskName;
	public List<TaskProperties> taskProperties= new ArrayList<>();
	
	//Badges score values
	public List<Double> generalMetricsScoreValues = new ArrayList<>();
	public List<Double> conditionalStatementMetricsScoreValues = new ArrayList<>();
	public List<Double> inherhitanceMetricsScoreValues = new ArrayList<>();
	public List<Double> iterationMetricsScoreValues = new ArrayList<>();
	public List<Double> exeptionMetricsScoreValues = new ArrayList<>();
	public List<Double> overallMetricsScoreValues = new ArrayList<>();
	
	
	public ReadXMLFile(String fileName) {
		this.fileName = fileName;
		readFileName();
	}

    public void readFileName() {

	    try {
	    	System.out.println(fileName);
			File fXmlFile = new File(fileName);
			
			System.out.println(fXmlFile);
			DocumentBuilderFactory dbFactory = DocumentBuilderFactory.newInstance();
			DocumentBuilder dBuilder = dbFactory.newDocumentBuilder();
			Document doc = dBuilder.parse(fXmlFile);
		
			//optional, but recommended
			//read this - http://stackoverflow.com/questions/13786607/normalization-in-dom-parsing-with-java-how-does-it-work
			doc.getDocumentElement().normalize();
		
	//		System.out.println("Root element :" + doc.getDocumentElement().getNodeName());
			NodeList nList = doc.getElementsByTagName("assignment");
			
	//		System.out.println("----------------------------");
		
			for (int temp = 0; temp < nList.getLength(); temp++) {
				Node nNode = nList.item(temp);
				System.out.println("\nCurrent Element :" + nNode.getNodeName());
				
				if (nNode.getNodeType() == Node.ELEMENT_NODE) {
		
					Element eElement = (Element) nNode;
		
					taskName = eElement.getAttribute("name");	
					for (int temp2 = 0; temp2 < eElement.getElementsByTagName("task").getLength(); temp2++){
						taskProperties.add(new TaskProperties(eElement.getElementsByTagName("task").item(temp2).getAttributes().getNamedItem("id").getTextContent(), eElement.getElementsByTagName("task").item(temp2).getTextContent()));
					}
					
					for (int temp3 = 0; temp3 < eElement.getElementsByTagName("score").getLength(); temp3++){
						String key = eElement.getElementsByTagName("score").item(temp3).getAttributes().getNamedItem("id").getTextContent();
						String value = eElement.getElementsByTagName("score").item(temp3).getTextContent();
						setCorrectProperty(key, value);
					}
					//System.out.println("Task: " + eElement.getElementsByTagName("task").item(0).getTextContent());
					//System.out.println("Score : " + eElement.getElementsByTagName("score").item(0).getTextContent());
		
				}
			}
	    } catch (Exception e) {
		e.printStackTrace();
	    }
	    
	
    }
    
    public void setCorrectProperty(String key, String value) {
		
		if(key.equals("GeneralMetrics")){
			List<String> strings = Arrays.asList(value.split(","));
			strings.forEach(item->generalMetricsScoreValues.add(Double.parseDouble(item)));
			
		}
		else if(key.equals("ConditionalStatementMetrics")){
			List<String> strings = Arrays.asList(value.split(","));
			strings.forEach(item->conditionalStatementMetricsScoreValues.add(Double.parseDouble(item)));
		}
		else if(key.equals("ExceptionMetrics")){
			List<String> strings = Arrays.asList(value.split(","));
			strings.forEach(item->exeptionMetricsScoreValues.add(Double.parseDouble(item)));
		}
		else if(key.equals("InheritanceMetrics")){
			List<String> strings = Arrays.asList(value.split(","));
			strings.forEach(item->inherhitanceMetricsScoreValues.add(Double.parseDouble(item)));
		}
		else if(key.equals("IterationMetrics")){
			List<String> strings = Arrays.asList(value.split(","));
			strings.forEach(item->iterationMetricsScoreValues.add(Double.parseDouble(item)));
		}
		else if(key.equals("OverallMetrics")){
			List<String> strings = Arrays.asList(value.split(","));
			strings.forEach(item->overallMetricsScoreValues.add(Double.parseDouble(item)));
		}
	}
    
    public String toString() {
    	return taskName +"\n"+
    			taskProperties.get(0).id + "\n"
    			+new ListPrinter(taskProperties.get(0).badges, "Relevant Badges: ")
    			+"generalMetrics score values: "+generalMetricsScoreValues + "\n"
    			+"conditionalStatements score values: " +conditionalStatementMetricsScoreValues + "\n"
    			+"overall Metrics score values: " +overallMetricsScoreValues + "\n";
    			
    }

}