package list.printer;


import java.io.File;

import file.handling.SolutionPathGenerator;
import metrics.collection.MetricsCollectionList;
import summary.metric.extraction.ConditionalStatementsSummary;
import summary.metric.extraction.MetricsSummary;

public class PrintProposedSolutionCyclomaticComplexity {
	private String solutionBasePath;
	private ConditionalStatementsSummary conditionalStatementMetrics;
	private String task;
	
	public PrintProposedSolutionCyclomaticComplexity(String solutionBasePath, String task) {
		this.solutionBasePath = solutionBasePath + task;
		this.task=task;
		generateCyclomaticComplexityList();
		System.out.println("cyclomatic complexity for "+task +": ");
			
			System.out.println("\t"+conditionalStatementMetrics.cyclomaticComplexity);

	}
	
	private void generateCyclomaticComplexityList() {
        File solutionProjectDir = new File(solutionBasePath);
        SolutionPathGenerator solutionPathGenerator = new SolutionPathGenerator(solutionProjectDir);
        MetricsCollectionList solutionMetricsCollectionList = new MetricsCollectionList(solutionPathGenerator.pathList , solutionBasePath);
        MetricsSummary metricsSummary = new MetricsSummary(solutionMetricsCollectionList); 
        conditionalStatementMetrics = metricsSummary.conditionalStatementsMetrics;
	}

}
