package list.printer;

import java.io.File;

import badges.OverallMetricsBadge;
import file.handling.SolutionPathGenerator;
import metrics.collection.MetricsCollectionList;
import summary.metric.extraction.MetricsSummary;

public class SolutionOverallMetricsPrinter {
	private String solutionBasePath;
	private OverallMetricsBadge overallMetricsBadge;
	public SolutionOverallMetricsPrinter(String solutionBasePath) {
		this.solutionBasePath = solutionBasePath;
		generateOverallMetricsList();
		System.out.println("Unused metrics for proposed solution: ");
		for(String unusedMetrics: overallMetricsBadge.unusedMetrics) {
			System.out.println("\t"+unusedMetrics);
		}

	}
	
	private void generateOverallMetricsList() {
        File solutionProjectDir = new File(solutionBasePath);
        SolutionPathGenerator solutionPathGenerator = new SolutionPathGenerator(solutionProjectDir);
        MetricsCollectionList solutionMetricsCollectionList = new MetricsCollectionList(solutionPathGenerator.pathList , solutionBasePath);
        MetricsSummary metricsSummary = new MetricsSummary(solutionMetricsCollectionList); 
        overallMetricsBadge = new OverallMetricsBadge(metricsSummary);
	}

}
