package main;

import badges.BadgeCollection;
import file.handling.FilteredSolutionPathGenerator;
import file.handling.GetStudentCodeSource;
import file.handling.ReadXMLFile;
import file.handling.StudentPathGenerator;
import list.printer.ListOfSolutionsGenerator;
import list.printer.PrintProposedSolutionCyclomaticComplexity;
import list.printer.SolutionBadgeSimulation;
import list.printer.SolutionOverallMetricsPrinter;
import metrics.collection.MetricsCollectionList;
import summary.metric.extraction.MetricsSummary;


public class Main {
	


		public static void main(String[] args) throws Exception{
    	
       	// Sources			replace ... with local path 
    	String solutionBasePath = ".../masteroppgave/Kode/losningsforslag/src";
        String studentBasePath = ".../masteroppgave/Kode/studentkode/oving8/3859682896";
          
        
        //  Solution and student name generator - fileNameGenerator = new SolutionAndStudentFileNameGenerator(studentBasePath, solutionBasePath);
        StudentPathGenerator studentPath = new StudentPathGenerator(studentBasePath);
        
        //Student metrics
        GetStudentCodeSource studentCodeList = new GetStudentCodeSource(studentPath.pathList, studentBasePath);
        MetricsCollectionList studentMetricsCollectionList = new MetricsCollectionList(studentCodeList.studentCodeList);
        MetricsSummary studentMetricsSummary = new MetricsSummary(studentMetricsCollectionList);
        System.out.println("STUDENT CODE METRICS: \n" + studentMetricsSummary + "\n\n\n");
        //System.out.println("Student code metrics are calculated from these files: \n" +studentBasePath+"\n"+ studentPath.pathList);
        
        //Solution Metrics
        FilteredSolutionPathGenerator filteredSolutionFileList = new FilteredSolutionPathGenerator(studentCodeList.studentCodePackageNameList, solutionBasePath);
        MetricsCollectionList solutionMetricsCollectionList = new MetricsCollectionList(filteredSolutionFileList.solutionFileNameList, solutionBasePath);
        MetricsSummary solutionMetricsSummary = new MetricsSummary(solutionMetricsCollectionList);
        System.out.println("SOLUTION CODE METRICS: \n" + solutionMetricsSummary);
        //System.out.println("SOLUTION METRICS ARE CALCULATED FROM \n" +solutionBasePath +"\n and this list: " +  filteredSolutionFileList.solutionFileNameList);
        
        //PropertiesFile 
    //    ReadPropertiesXmlFile xmlProperties = new ReadPropertiesXmlFile("C:/Users/Syver/masteroppgave/MavenJavaProject/my-app/properties.xml");
        ReadXMLFile xmlProperties = new ReadXMLFile("C:/Users/Syver/masteroppgave/MavenJavaProject/my-app/properties.xml");
		
        //Badges
        BadgeCollection badgeCollection = new BadgeCollection(studentMetricsSummary, solutionMetricsSummary, xmlProperties, "5-1");
        System.out.println(badgeCollection);
        
        
        
        //Simulation with proposed solution 
        
        
        
        //Print Cyclomatic complexity from proposed Solution  
        PrintProposedSolutionCyclomaticComplexity solutionCyclomaticComplexityPrinter= new PrintProposedSolutionCyclomaticComplexity(solutionBasePath, "/inheritance/easyCardContainer");
        
        
        //Get unused metrics from proposed Solution  
        SolutionOverallMetricsPrinter solutionOverallMetricsPrinter= new SolutionOverallMetricsPrinter(solutionBasePath+"/assignmentFiveSixEightNine");
        
      
        //Print relevant metrics for each task 
        ListOfSolutionsGenerator listOfSolutionsGenerator = new ListOfSolutionsGenerator();
        SolutionBadgeSimulation solutionBadgeSimulation = new SolutionBadgeSimulation(solutionBasePath, listOfSolutionsGenerator.assignmentFiveTasks);
        
        

		}
		
		
        
}


