package metrics.collection;

import java.io.ByteArrayInputStream;
import java.io.FileInputStream;
import java.io.FileNotFoundException;
import java.io.InputStream;
import java.util.ArrayList;
import java.util.List;

import com.github.javaparser.JavaParser;
import com.github.javaparser.ast.CompilationUnit;
import list.printer.ListPrinter;



public class MetricsCollectionList {
	private List<String> pathNames = new ArrayList<String>();
	private String basePath; 
	public List<MetricsCollection> metricsCollectionList = new ArrayList<MetricsCollection>();
	private List<String> studentCodeList = new ArrayList<String>();
	
	public MetricsCollectionList(List<String> pathNames, String basePath) {
		this.basePath = basePath;
		this.pathNames = pathNames;

		generateMetricsList();
		
	}
	
	public MetricsCollectionList( List<String> studentCodeList) {
		this.studentCodeList = studentCodeList; 
		generateStudentMetricsList();
	}
	
	public void generateMetricsList() {
		for (String path:pathNames) {
			
			//make file input Stream 
			FileInputStream inputStream;
			try {
				inputStream = new FileInputStream(basePath + path);
				CompilationUnit compilationUnit = JavaParser.parse(inputStream);
				//Calculate metrics for this path 
				MetricsCollection metricsCollection = new MetricsCollection(compilationUnit);
			    metricsCollectionList.add(metricsCollection);
			} catch (FileNotFoundException e) {
				e.printStackTrace();
			}			
		}	
	}
	
	public void generateStudentMetricsList() {
		for (String studentCode: studentCodeList) {
			InputStream studentCodeInputStream = new ByteArrayInputStream(studentCode.getBytes());
			CompilationUnit compilationUnit = JavaParser.parse(studentCodeInputStream);
			MetricsCollection metricsCollection = new MetricsCollection(compilationUnit);
			metricsCollectionList.add(metricsCollection);
		}
		
	}
		
	public String toString() {
		return 
				new ListPrinter(metricsCollectionList, "MetricsCollectionList") +
				"This is the list of all the metrics, there are \n "
				+ metricsCollectionList.size() + 
				" Number of files with metrics \n";
				
	}

}


/*

int pos = studentCode.lastIndexOf("package");
if (pos >= studentCode.length() / 2) {
	studentCode = studentCode.substring(0, pos);
}
InputStream studentCodeInputStream = new ByteArrayInputStream(studentCode.getBytes());
try {
	CompilationUnit compilationUnit = JavaParser.parse(studentCodeInputStream);
	MetricsCollection metricsCollection = new MetricsCollection(compilationUnit);
	metricsCollectionList.add(metricsCollection);
}
catch (RuntimeException re) {
	System.out.println("Parsing " + studentCode);
	System.err.println(re);
}

*/


/*
	for (String path:pathNames) {
		//make file input Stream 
		FileInputStream inputStream;
		try {
			inputStream = new FileInputStream(basePath + path);
			CompilationUnit compilationUnit = JavaParser.parse(inputStream);
			//Calculate metrics for this path 
			MetricsCollection metricsCollection = new MetricsCollection(compilationUnit);
		    metricsCollectionList.add(metricsCollection);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}			
	}
	*/

