package metrics.conditional.statements;

import java.util.List;

import org.apache.commons.lang3.StringUtils;

import com.github.javaparser.ast.expr.Expression;

public class ConditionalOperatorCounter {
	public int numberOfEquals = 0;
	public int numberOfNotEquals =0;
	public int numberOfAnd = 0;
	public int numberOfOr = 0;
	public int numberOfLessThan = 0;
	public int numberOfMoreThan = 0;
	public int numberOfLessOrEqual = 0;
	public int numberOfMoreOrEqual = 0; 
	public int numberOfBooleanFunctions = 0;

	public ConditionalOperatorCounter(List<Expression> conditionList) {
		countOperators(conditionList);
	}
	
	public void countOperators(List<Expression> conditionList) {

		for (Expression expression:conditionList) {
			numberOfEquals += StringUtils.countMatches(expression.toString(), "==");
			numberOfNotEquals += StringUtils.countMatches(expression.toString(), "!");
			numberOfAnd += StringUtils.countMatches(expression.toString(), "&&");
			numberOfOr += StringUtils.countMatches(expression.toString(), "||");
			numberOfLessThan += StringUtils.countMatches(expression.toString(), "<");
			numberOfMoreThan += StringUtils.countMatches(expression.toString(), ">");
			numberOfLessOrEqual += StringUtils.countMatches(expression.toString(), "<=");
			numberOfMoreOrEqual += StringUtils.countMatches(expression.toString(), ">=");
			
			if(!StringUtils.contains(expression.toString(), "=" )&&!StringUtils.contains(expression.toString(), ">" )&&!StringUtils.contains(expression.toString(), "<" ))
				numberOfBooleanFunctions += StringUtils.countMatches(expression.toString(), "()");			
		}
		
	}
	
	public String toString() {
		return "\nConditional Operators: " +
				"Number of equals (==); " +numberOfEquals+"\n"+
				"Number of not equals (!=); " +numberOfNotEquals+"\n"+
				"Number of And (&&); " +numberOfAnd+"\n"+
				"Number of Or (||); " +numberOfOr+"\n"+
				"Number of less than (<); " +numberOfLessThan+"\n"+
				"Number of more than (<); " +numberOfMoreThan+"\n"+
				"Number of less or equal (<=); " +numberOfLessOrEqual+"\n"+
				"Number of more or equal (>=); " +numberOfMoreOrEqual+"\n"+
				"Number of boolean functions + numberOfBooleanFunctions"
				;
	}
}
