package metrics.general;

import java.util.List;
import org.apache.commons.lang3.StringUtils;


public class UnaryOperators {
	
	private List<String> unaryExprList;
	public int numberOfMultiply;
	public int numberOfDivide;
	public int numberOfAddition; 
	public int numberOfSubtraction;
	public int numberOfPlusOne;
	public int numberOfMinusOne;
	public int numberOfBooleanInverter;
	public int numberOfRemains;
	
	public UnaryOperators(List<String> unaryExprList) {
		this.unaryExprList = unaryExprList;
		countUnaryOperators();
	}
	
	private void countUnaryOperators() {
		for(String unaryExpr:unaryExprList) {
			numberOfMultiply += StringUtils.countMatches(unaryExpr, "*");
			numberOfDivide += StringUtils.countMatches(unaryExpr, "/");
			numberOfAddition += StringUtils.countMatches(unaryExpr, "+");
			numberOfPlusOne += StringUtils.countMatches(unaryExpr, "++");
			numberOfSubtraction += StringUtils.countMatches(unaryExpr, "-");
			numberOfMinusOne += StringUtils.countMatches(unaryExpr, "--");
			numberOfRemains += StringUtils.countMatches(unaryExpr, "%");
			numberOfBooleanInverter += StringUtils.countMatches(unaryExpr, "!");
		}
		//Fix that "++" and "--" is counted as 2 x "+" and 2 x "-"
		numberOfAddition = numberOfAddition - (numberOfPlusOne*2);
		numberOfSubtraction = numberOfSubtraction - (numberOfMinusOne*2);
	}
	
	

}
