package metrics.java.standard.methods;
import java.util.ArrayList;
import com.github.javaparser.ast.CompilationUnit;
import com.github.javaparser.ast.expr.StringLiteralExpr;
import com.github.javaparser.ast.visitor.VoidVisitorAdapter;

import list.printer.ListPrinter;

//Java Standard classes
public class JavaStandardClassMethodsMetric {
	CompilationUnit source;
	ArrayList<StringLiteralExpr> stringLiteralExprList = new ArrayList<>();
		
	public JavaStandardClassMethodsMetric(CompilationUnit source) {
			this.source = source;
			calculateMetrics();
	}
		
	public void calculateMetrics() {
		createStringLiteralExprList();
	};
	
		
	private void createStringLiteralExprList() {
		source.accept(new VoidVisitorAdapter<Void>(){
			    @Override
	            public void visit(final StringLiteralExpr n, final Void arg){
			    	stringLiteralExprList.add(n);
	                super.visit(n, arg);
	            };
	        }, null);
	} 

	
    public String toString() {
    	if (stringLiteralExprList.isEmpty())
    		return "";
    	else { 	
    		return "STRING MANIPULATION METRICS: \n\n" + 
            		new ListPrinter(stringLiteralExprList,"String literal expression list : ");   	
    		} 			
    }
}



