package summary.metric.extraction;

import java.util.List;

import metrics.collection.MetricsCollection;
import metrics.collection.MetricsCollectionList;

public class InheritanceMetricsSummary {

	private List<MetricsCollection> metricsCollectionList;
	public int totalAbstractClassOrInterfaceInheritance = 0;
	//private int totalClassOrInterfaceTypeList =0;
	public int totalSuperExprList = 0;
	
	public InheritanceMetricsSummary(MetricsCollectionList mcl) {
		this.metricsCollectionList = mcl.metricsCollectionList;
		calculateMetrics();
	}
	
	public void calculateMetrics() {
		for(MetricsCollection metricsCollection: metricsCollectionList) {
			totalAbstractClassOrInterfaceInheritance = totalAbstractClassOrInterfaceInheritance + metricsCollection.inheritanceMetrics.classOrInterfaceDeclarationList.size();
			//totalClassOrInterfaceTypeList = totalClassOrInterfaceTypeList + metricsCollection.inheritanceMetrics.classOrInterfaceTypeList.size();
			totalSuperExprList = totalSuperExprList + metricsCollection.inheritanceMetrics.superExprList.size();
		}
	
	}
	
	private String printIfNotZero (String s, int n) {
		if(n==0) {
			return "";
		}
		else {
			return s + n;
		}
	}
	

	
	public String toString() {
		return "InheritanceMetricsSummary\n" +
				printIfNotZero("\tTotal amount of abstract class or interface inheritance: " ,totalAbstractClassOrInterfaceInheritance) +
				//+ "\tTotal amount of class and interface typeList: " +totalClassOrInterfaceTypeList+ "\n"
				printIfNotZero("\n\tTotal amount of super expressions: " ,totalSuperExprList) + "\n";
	}
	

}
