package summary.metric.extraction;

import java.util.List;

import metrics.collection.MetricsCollection;
import metrics.collection.MetricsCollectionList;


public class IterableMetricsSummary {

	private List<MetricsCollection> metricsCollectionList;
	public int totalArrayInit = 0;
	public int totalArrayCreations =0;
	public int totalArrayAccesses = 0;
	
	public IterableMetricsSummary(MetricsCollectionList mcl) {
		this.metricsCollectionList = mcl.metricsCollectionList;
		calculateMetrics();
	}
	
	public void calculateMetrics() {
		for(MetricsCollection metricsCollection: metricsCollectionList) {
			totalArrayInit = totalArrayInit + metricsCollection.iterableMetrics.arrayInitExprList.size();
			totalArrayCreations = totalArrayCreations + metricsCollection.iterableMetrics.arrayCreationExprList.size();
			totalArrayAccesses = totalArrayAccesses + metricsCollection.iterableMetrics.arrayAccessExprList.size();
		}
		/*for (ForStmt forStatement: metricsCollection.iteratorMetrics.forStatementList) {
		
		}*/		
	}
	
	private String printIfNotZero (String s, int n) {
		if(n==0) {
			return "";
		}
		else {
			return s + n;
		}
	}
	
	
	public String toString() {
		return "IterableMetricsSummary\n" +
				printIfNotZero("\tTotal amount of array inits: " ,totalArrayInit )+ 
				printIfNotZero("\n\tTotal amount of array creations: " ,totalArrayCreations)+ 
				printIfNotZero("\n\tTotal amount of array accesses: " ,totalArrayAccesses) + "\n";
	}
	

}
