package summary.metric.extraction;

import java.util.List;
import metrics.collection.MetricsCollection;
import metrics.collection.MetricsCollectionList;


public class IteratorMetricsSummary {

	private List<MetricsCollection> metricsCollectionList;
	public int totalForLoops = 0;
	public int totalForeachLoops =0;
	public int totalWhileLoops = 0;
	public int totalLambdaExpr =0;
	
	public IteratorMetricsSummary(MetricsCollectionList mcl) {
		this.metricsCollectionList = mcl.metricsCollectionList;
		calculateMetrics();
	}
	
	public void calculateMetrics() {
		countIterables();
		
	}
	
	public void countIterables() {
		for(MetricsCollection metricsCollection: metricsCollectionList) {
			totalForLoops = totalForLoops + metricsCollection.iteratorMetrics.foreachStatementList.size();
			totalWhileLoops = totalWhileLoops + metricsCollection.iteratorMetrics.foreachStatementList.size();
			totalForeachLoops = totalForeachLoops + metricsCollection.iteratorMetrics.foreachStatementList.size();
			totalLambdaExpr = totalLambdaExpr + metricsCollection.iteratorMetrics.lambdaExpressionList.size();
			
			/*for (ForStmt forStatement: metricsCollection.iteratorMetrics.forStatementList) {
			
			}*/

		}
		
	}
	
	private String printIfNotZero (String s, int n) {
		if(n==0) {
			return "";
		}
		else {
			return s + n;
		}
	}
	
	public String toString() {
		return "IteratorMetricsSummary\n" 
				+ printIfNotZero ("\tTotal amount of Foreach loops: " ,totalForeachLoops )
				+ printIfNotZero ("\n\tTotal amount of For loops: " ,totalForLoops )
				+ printIfNotZero ("\n\tTotal amount of While loops: " ,totalWhileLoops)
				+ printIfNotZero ("\n\tTotal amount of Lambda expressions: " ,totalLambdaExpr) + "\n";
	}
	

}
