package summary.metric.extraction;

import metrics.collection.MetricsCollectionList;

public class MetricsSummary {

	public ConditionalStatementsSummary conditionalStatementsMetrics;
	public ExceptionMetricsSummary exceptionMetricsSummary;
	public GeneralMetricsSummary generalMetricsSummary;
	public IteratorMetricsSummary iteratorMetricsSummary;
	public IterableMetricsSummary iterableMetricsSummary;
	public InheritanceMetricsSummary inheritanceMetricsSummary;

	public MetricsSummary(MetricsCollectionList mcl) {

		this.conditionalStatementsMetrics = new ConditionalStatementsSummary(mcl);
		this.exceptionMetricsSummary = new ExceptionMetricsSummary(mcl);
		this.generalMetricsSummary = new GeneralMetricsSummary(mcl);
		this.iteratorMetricsSummary = new IteratorMetricsSummary(mcl);
		this.iterableMetricsSummary = new IterableMetricsSummary(mcl);
		this.inheritanceMetricsSummary = new InheritanceMetricsSummary(mcl);
	
	
	}

	
	public String printCyclomaticComplexity() {
		return "Cyclomatic complexity: " +conditionalStatementsMetrics.cyclomaticComplexity;
	}
	
	public String toString() {
		return "MetricsSummary: \n\n" + 
				conditionalStatementsMetrics +"\n"+
				exceptionMetricsSummary +"\n"+
				generalMetricsSummary +"\n"+
				iteratorMetricsSummary +"\n"+
				iterableMetricsSummary +"\n"+
				inheritanceMetricsSummary;
	}
		
}
