package symbol.solver;

import com.github.javaparser.ast.body.MethodDeclaration;
import com.github.javaparser.ast.expr.MethodCallExpr;
import com.github.javaparser.ast.stmt.ReturnStmt;
import com.github.javaparser.ast.visitor.VoidVisitorAdapter;
import com.github.javaparser.resolution.types.ResolvedReferenceType;
import com.github.javaparser.symbolsolver.javaparsermodel.JavaParserFacade;

public class SymbolSolverVisitor extends VoidVisitorAdapter<JavaParserFacade> {
    @Override
    public void visit(ReturnStmt n, JavaParserFacade javaParserFacade) {
        super.visit(n, javaParserFacade);
        //System.out.println(n.getExpr().toString() + " has type " + javaParserFacade.getType(n.getExpr()));
    }
    


    @Override
    public void visit(MethodCallExpr n, JavaParserFacade javaParserFacade) {
        super.visit(n, javaParserFacade);
      //  System.out.println(n.toString() + " Has type :" + javaParserFacade.getType(n).describe());
        if (javaParserFacade.getType(n).isReferenceType()) {
            for (ResolvedReferenceType ancestor : javaParserFacade.getType(n).asReferenceType().getAllAncestors()) {
               // System.out.println("Ancestor " + ancestor.describe());
               // System.out.println("Qualified name : "+ancestor.getQualifiedName());
            }
        }
    }
}
