
//History: 
function metric(name, score, badgeRequirement, propertyList, unusedMetrics){
	this.name = name; 
	this.score = score;
	this.badgeRequirement = badgeRequirement;
	this.propertyList = propertyList;
	this.info = "some information about this metric";
	this.unusedMetrics = unusedMetrics;
};


function property(name, score=0, solutionScore=0){
	this.name = name;
	this.score = score;
	this.solutionScore = solutionScore;

	return name +" "+score;
}

function metricsListAssignmentFive(studentComplexityList, nextBadgeList ){
	var metricList=[];
	if(!studentComplexityList[0] == 0 && !nextBadgeList[0] ==0){	
		metricList.push(new metric("General Metrics", studentComplexityList[0], nextBadgeList[0], [new property("Number of lines : ", 163, 89), new property("Method calls: ", 68, 25) , new property("Variables declared: ", 20, 7), new property("Weighted methods per class: ", 18, 8)]));
	}	 
	if(!studentComplexityList[1] == 0 && !nextBadgeList[1] ==0){
		metricList.push(new metric("Conditional Statement Metrics", studentComplexityList[1], nextBadgeList[1], [new property("Number of ifs : ", 20, 12), new property("Number of elses : ", 15, 2) , new property("Number of switches: ", 0, 0), new property("Cyclomatic complexity: ", 19, 6)]));
	}
	if(!studentComplexityList[2] == 0 && !nextBadgeList[2] ==0){
		metricList.push(new metric("Inheritance Metrics", studentComplexityList[2], nextBadgeList[2], [new property("Classes/Interfaces used : ", 3, 3), new property("Number of super expressions:  ", 0, 0)]));
	}
	if(!studentComplexityList[3] == 0 && !nextBadgeList[3] ==0){
		metricList.push(new metric("Iteration Metrics", studentComplexityList[3], nextBadgeList[3],  [new property("Number of array inits : ", 1, 0), new property("Number of array accesses : ", 2), new property("Number of foreach loops: ", 2,0) , new property("Number of while loops: ", 1,0)] ));
	}
	if(!studentComplexityList[4] == 0 && !nextBadgeList[4] ==0){
		metricList.push(new metric("Exception Metrics", studentComplexityList[4], nextBadgeList[4], [new property("Number of throw statements: ", 1, 1)]));
	}
	if(!studentComplexityList[5] == 0 && !nextBadgeList[5] ==0){
		metricList.push(new metric("Overall Metrics", studentComplexityList[5], nextBadgeList[5],[
			new property("For"), 
			new property("Lambda"),
			new property("ArrayCreation"), 
			new property("Switches"),
			new property("BooleanOperatorOr"), 
			new property("BooleanOperatorMoreOrEqual"),
			new property("BooleanOperatorLessOrEqual"), 
			new property("UnaryOperatorAddition"),
			new property("UnaryOperatorMultiply"), 
			new property("UnaryOperatorDivide"),
			new property("UnaryOperatorRemains"), 
			new property("PublicFieldDeclaration"),
			new property("ProtectedFieldDeclaration")
			]));
	}
	return metricList;
};

function metricsListAssignmentSix(studentComplexityList, nextBadgeList ){
	var metricList=[];
	if(!studentComplexityList[0] == 0 && !nextBadgeList[0] ==0){	
		metricList.push(new metric("General Metrics", studentComplexityList[0], nextBadgeList[0], [new property("Number of lines : ", 163, 89), new property("Method calls: ", 68, 25) , new property("Variables declared: ", 20, 7), new property("Weighted methods per class: ", 18, 8)]));
	}	 
	if(!studentComplexityList[1] == 0 && !nextBadgeList[1] ==0){
		metricList.push(new metric("Conditional Statement Metrics", studentComplexityList[1], nextBadgeList[1], [new property("Number of ifs : ", 20, 12), new property("Number of elses : ", 15, 2) , new property("Number of switches: ", 0, 0), new property("Cyclomatic complexity: ", 19, 6)]));
	}
	if(!studentComplexityList[2] == 0 && !nextBadgeList[2] ==0){
		metricList.push(new metric("Inheritance Metrics", studentComplexityList[2], nextBadgeList[2], [new property("Classes/Interfaces used : ", 3, 3), new property("Number of super expressions:  ", 0, 0)]));
	}
	if(!studentComplexityList[3] == 0 && !nextBadgeList[3] ==0){
		metricList.push(new metric("Iteration Metrics", studentComplexityList[3], nextBadgeList[3],  [new property("Number of array inits : ", 1, 0), new property("Number of array accesses : ", 2), new property("Number of foreach loops: ", 2,0) , new property("Number of while loops: ", 1,0)] ));
	}
	if(!studentComplexityList[4] == 0 && !nextBadgeList[4] ==0){
		metricList.push(new metric("Exception Metrics", studentComplexityList[4], nextBadgeList[4], [new property("Number of throw statements: ", 1, 1)]));
	}
	if(!studentComplexityList[5] == 0 && !nextBadgeList[5] ==0){
		metricList.push(new metric("Overall Metrics", studentComplexityList[5], nextBadgeList[5],[
			new property("For"), 
			new property("Lambda"),
			new property("ArrayCreation"), 
			new property("Switches"),
			new property("BooleanOperatorOr"), 
			new property("BooleanOperatorMoreOrEqual"),
			new property("BooleanOperatorLessOrEqual"), 
			new property("UnaryOperatorAddition"),
			new property("UnaryOperatorMultiply"), 
			new property("UnaryOperatorDivide"),
			new property("UnaryOperatorRemains"), 
			new property("PublicFieldDeclaration"),
			new property("ProtectedFieldDeclaration")
			]));
	}
	return metricList;
};



//needs input of person ID 
function previousAssignmentsSQLRequest(){
	var assignmentsArray = [];                                 //((generalScore, conditionalScore, inheritanceScore, iterationScore, exceptionScore, overallScore)
	assignmentsArray.push({name:"Assignment 5", metrics: metricsListAssignmentFive([4.71, 5.29, 10, 0, 0, 6], /*solution score ->*/ [88, 11, 100, 0, 0, 30] )});
	assignmentsArray.push({name:"Assignment 6", metrics: metricsListAssignmentSix([4.14, 4.38, 10, 0, 10, 17],/*solution score ->*/ [59, 72, 100, 0, 100, 30] )});

	return assignmentsArray;
};

function arrayContains(item, array)
{
	if(array.length===0){
		return true;
	}
	var notEquals = true;
    for(i = 0; i<array.length; i++){
    	if(item == array[i]){
    		notEquals = false;
    	}
    }
    return notEquals;
}

function getSummary(assignments){
	generalCounter=0.0;
	conditionalCounter=0.0;
	inheritanceCounter=0.0;
	iterationCounter = 0.0;
	exceptionCounter =0.0;
	overallSum = 0.0;

	generalSum = 0.0;
	conditionalSum = 0.0;
	inheritanceSum=0.0;
	iterationSum = 0.0;
	exceptionSum=0.0;


	var unusedMetricsList = []

	assignments.forEach( assignment => { 
		assignment.metrics.forEach( metric => { 
			if (metric.name == "General Metrics"){generalSum = generalSum + metric.score; generalCounter = generalCounter +1;};
			if (metric.name == "Conditional Statement Metrics"){conditionalSum = conditionalSum + metric.score; conditionalCounter = conditionalCounter +1;};
			if (metric.name == "Inheritance Metrics"){inheritanceSum = inheritanceSum + metric.score; inheritanceCounter = inheritanceCounter +1;}; 
			if (metric.name == "Iteration Metrics"){iterationSum = iterationSum + metric.score; iterationCounter = iterationCounter +1;}; 
			if (metric.name == "Exception Metrics"){exceptionSum = exceptionSum + metric.score; exceptionCounter = exceptionCounter +1;}; 
			if (metric.name == "Overall Metrics"){
				for (i = 0; i < metric.propertyList.length-1; i++){
					if(arrayContains(metric.propertyList[i], unusedMetricsList)){
						unusedMetricsList.push(metric.propertyList[i].name)
					}
				};
			}; 
		});
	});

	solutionGeneralCounter=0.0;
	solutionConditionalCounter=0.0;
	solutionInheritanceCounter=0.0;
	solutionIterationCounter = 0.0;
	solutionExceptionCounter =0.0;

	solutionGeneralSum = 0.0;
	solutionConditionalSum = 0.0;
	solutionInheritanceSum=0.0;
	solutionIterationSum = 0.0;
	solutionExceptionSum=0.0;
	solutionOverallSum=0.0;

	assignments.forEach( assignment => { 
		assignment.metrics.forEach( metric => { 
			if (metric.name == "General Metrics"){solutionGeneralSum = solutionGeneralSum + metric.solutionScore; solutionGeneralCounter = solutionGeneralCounter +1;};
			if (metric.name == "Conditional Statement Metrics"){solutionConditionalSum = solutionConditionalSum + metric.solutionScore; solutionConditionalCounter = solutionConditionalCounter +1;};
			if (metric.name == "Inheritance Metrics"){solutionInheritanceSum = solutionInheritanceSum + metric.solutionScore; solutionInheritanceCounter = solutionInheritanceCounter +1;}; 
			if (metric.name == "Iteration Metrics"){solutionIterationSum = solutionIterationSum + metric.solutionScore; solutionIterationCounter = solutionIterationCounter +1;}; 
			if (metric.name == "Exception Metrics"){solutionExceptionSum = solutionExceptionSum + metric.solutionScore; solutionExceptionCounter = solutionExceptionCounter +1;}; 
			if (metric.name == "Overall Metrics"){solutionOverallSum = metric.badgeRequirement;}; 
		}) 
	});


	return {name: "Summary", metrics: metricsListAssignmentSix((generalSum/generalCounter).toFixed(2),(conditionalSum/conditionalCounter).toFixed(2),(inheritanceSum/inheritanceCounter).toFixed(2)
		,(iterationSum/iterationCounter).toFixed(2),(exceptionSum/exceptionCounter).toFixed(2),(solutionOverallSum-unusedMetricsList.length).toFixed(2), /*Solution summary scores ->*/
		(solutionGeneralSum/solutionGeneralCounter).toFixed(2),(solutionConditionalSum/solutionConditionalCounter).toFixed(2),(solutionInheritanceSum/solutionInheritanceCounter).toFixed(2)
		,(solutionIterationSum/solutionIterationCounter).toFixed(2),(solutionExceptionSum/solutionExceptionCounter).toFixed(2),(solutionOverallSum).toFixed(2)) };
};


//BADGES:
function badge(name, score, remaining){
	this.name = name;
	this.info = "";
	this.remaining = remaining;
	this.path = "img/" +name+"Bronze.png" 
	this.showBadge = false;
	this.showRemainingBadge = true;
	if (score>=3){
		this.name = name + " Bronze" ;
		this.info = "Here is some information about this bronze badge.";
		this.showBadge = true;
		this.showRemainingBadge = false; 	
	}
	if (score>=6){
		this.name = name + " Silver" ;
		this.info = "Some information about this Silver badge.";
		this.showBadge = true;
		this.showRemainingBadge = false;
		this.path = "img/" +name+"Silver.png" 	
	}
	if (score>=9){
		this.name = name + " Gold" ;
		this.info = "Some information about this Gold badge.";
		this.showBadge = true;
		this.showRemainingBadge = false;
		this.path = "img/" +name+"Gold.png" 	
	}

};

function getBadges(){
	var badges = [];
	badges.push(new badge("ConditionalStatements", 3,0.4));
	badges.push(new badge("Iteration", 6,0.6));
	badges.push(new badge("General", 1,0.9));
	badges.push(new badge("Inheritance", 2,0.1));
	badges.push(new badge("Exception", 9,0.4));
	badges.push(new badge("Overall", 1,0.4));	
	return badges;
}

function propertyPrinter(property){
	var propertyPrint = document.createElement("tr");
	var tableNames = document.createElement("td");
	tableNames.appendChild(document.createTextNode(property.name));
	var tableScore = document.createElement("td");
	tableScore.appendChild(document.createTextNode(property.score));
	var maxScore = document.createElement("td");
	maxScore.appendChild(document.createTextNode(property.solutionScore));
	propertyPrint.appendChild(tableNames);
	propertyPrint.appendChild(tableScore);
	propertyPrint.appendChild(maxScore);	    
	return propertyPrint;//property.name +"\t"+  property.score + "\n";
}

function unusedMetricsListPrinter(propertyList){
	var unusedMetricsList = document.createElement("ul");
	propertyList.forEach(function(property) {
		var metricName = document.createElement("li");
		metricName.appendChild(document.createTextNode(property.name));
		unusedMetricsList.appendChild(metricName);	
	});

	return unusedMetricsList;
}

function propertyListPrinter(propertyList){
	var propertyTable = document.createElement("table");
	var firstTableName = document.createElement("th");
	firstTableName.appendChild(document.createTextNode(""));
	var secondTableName = document.createElement("th");
	secondTableName.appendChild(document.createTextNode("You"));
	var thirdTableName = document.createElement("th");
	thirdTableName.appendChild(document.createTextNode("Solution"));
	propertyTable.appendChild(firstTableName);
	propertyTable.appendChild(secondTableName);
	propertyTable.appendChild(thirdTableName);
	propertyList.forEach(function(property) {
		propertyTable.appendChild(propertyPrinter(property));
	});
	
	return propertyTable;
}


function getNextBadge(badgePath){
	var nextBadge ="";
	if (badgePath.includes("Bronze")) {
		nextBadge = badgePath.replace("Bronze", "Silver");
	}
	if (badgePath.includes("Silver")) {
		nextBadge = badgePath.replace("Silver", "Gold");
	}
	if (badgePath.includes("Gold")) {
		nextBadge = badgePath.replace("Gold", "Gold");
	}
	return nextBadge;
	
}

function isGoldBadge(badgeName){
	if (badgeName.includes("Gold")) {
		return true;
	}
	else{
		return false;
	}

}
function viewModel() {
    var self = this;

    //View
    self.currentView = ko.observable();
    self.views = ko.observableArray(["History", "Badges"]);
    
    //Assignments
    //needs input with personID 
    self.assignments = previousAssignmentsSQLRequest();
    self.summary = getSummary(self.assignments);
    self.assignments.push(self.summary);
    self.currentAssignmentName = ko.observable("Summary");
    self.metrics= ko.observableArray(self.summary.metrics);
    
    self.showMetricInformation = function(foo){
    	if(foo.name === "Overall Metrics"){
    		swal({
	    		title: foo.name,
	    		text: "You've used "+foo.score + " of " + foo.badgeRequirement + " metrics. \n\nUnused Metrics:\n",
	    		content:  unusedMetricsListPrinter(foo.propertyList),
	    	});

    	}
    	
    	else{
	    	swal({
	    		title: foo.name,
	    		text: "This score is determined based on:\n",
	    		content:  propertyListPrinter(foo.propertyList),
	    	});
    	}
    } 

    self.changeCurrentAssignment = function(foo) {
     	viewModel.currentAssignment = foo;
     	self.currentAssignmentName(foo.name);
     	self.metrics(foo.metrics);          
    };


      //Badges
    self.badges = getBadges();
    self.showRemainingBadges = ko.observable(false);
    self.showBadges = ko.observable(true);

    self.showBadgeInformation = function(foo){
    	
		var progressBar = document.createElement("progress");        // Create a <button> element
		progressBar.setAttribute("value", ""+foo.remaining*100);
		progressBar.setAttribute("max", "100");
				
		  
    	if(isGoldBadge(foo.name)){
    		swal({
		 		title: foo.name,
				text: foo.info,
				icon: foo.path,
				//imageWidth: 400,
				//imageHeight: 200,
				imageAlt: 'Custom image',
				})
    	}

    	else{
    		    	swal({
 		title: foo.name,
		text: foo.info,
		icon: foo.path,
		//imageWidth: 400,
		//imageHeight: 200,
		imageAlt: 'Custom image',
  		buttons: {
		    cancel: "Back",
		    next: {
		      text: "Next badge",
		      value: "next",
		    },
		  },
		})
		.then((value) => {
		  switch (value) {
		 
		    case "next":
		      var nextPath = getNextBadge(foo.path);
		      var nextName = getNextBadge(foo.name);
		      swal({
				 		title: nextName,
						text: "Progress towards completing badge: ",
						icon: nextPath,
						content: progressBar,
						className: "grayOut",
						//imageClass: "imgGray",
						//imageAlt: 'Badge',
						//animation: false
				  
						})
		      break;
		 	
		  }
		});	
    	}
	}


    self.showRemainingBadgeInformation = function(foo){
    	var progressBar = document.createElement("progress");        // Create a <button> element
		progressBar.setAttribute("value", ""+foo.remaining*100);
		progressBar.setAttribute("max", "100");
    	
    	swal({
			title: foo.name,
			text: "Progress towards completing badge: ",
			icon: foo.path,
			content: progressBar, 
			//Image class or alt is not working in "Sweet Alert 2"
			className: "grayOut",
			
		});
    } 

    //Not using this at the moment 
    self.toggleRemainingBadges = function(){
	    if(self.showRemainingBadges()){
	    	self.showRemainingBadges(true);
	    }
	    else{
	    	self.showRemainingBadges(true);
	    }
	};

	//Not using this 
	self.toggleBadges = function(){
	    if(self.showBadges()){
	    	self.showBadges(true);
	    }
	    else{
	    	self.showBadges(true);
	    }
	};


};

var vm = new viewModel();
ko.applyBindings(vm);
Sammy(function () {
        this.get('#:view', function () {
            vm.currentView(this.params.view);
        });
    }).run('#History');

